#ifndef AZUL_H
#define AZUL_H

#include <stdbool.h>
#include <stdint.h>
#include <stddef.h>

/* C89 port for "restrict" keyword from C99 */
#if __STDC__ != 1
#    define restrict __restrict
#else
#    ifndef __STDC_VERSION__
#        define restrict __restrict
#    else
#        if __STDC_VERSION__ < 199901L
#            define restrict __restrict
#        endif
#    endif
#endif

/* cross-platform define for ssize_t (signed size_t) */
#ifdef _WIN32
    #include <windows.h>
    #ifdef _MSC_VER
        typedef SSIZE_T ssize_t;
    #endif
#else
    #include <sys/types.h>
#endif

/* cross-platform define for __declspec(dllimport) */
#ifdef _WIN32
    #define DLLIMPORT __declspec(dllimport)
#else
    #define DLLIMPORT
#endif

/* STRUCT DEFINITIONS */

/* MACROS for union enum construction and vector initialization */

/* Empty vec constructors */

/* FUNCTIONS */

extern DLLIMPORT AzApp AzApp_new(/* function args */);
extern DLLIMPORT void AzApp_addWindow(/* function args */);
extern DLLIMPORT void AzApp_addImage(/* function args */);
extern DLLIMPORT /* return type */ AzApp_getMonitors(/* function args */);
extern DLLIMPORT void AzApp_run(/* function args */);

extern DLLIMPORT AzAppConfig AzAppConfig_new(/* function args */);



extern DLLIMPORT AzSystemCallbacks AzSystemCallbacks_libraryInternal(/* function args */);

extern DLLIMPORT AzWindowCreateOptions AzWindowCreateOptions_new(/* function args */);





















extern DLLIMPORT AzLogicalPosition AzLogicalPosition_new(/* function args */);
extern DLLIMPORT AzLogicalPosition AzLogicalPosition_zero(/* function args */);

extern DLLIMPORT /* return type */ AzLogicalSize_toPhysical(/* function args */);








extern DLLIMPORT /* return type */ AzWindowSize_getHidpiFactor(/* function args */);




extern DLLIMPORT /* return type */ AzKeyboardState_shiftDown(/* function args */);
extern DLLIMPORT /* return type */ AzKeyboardState_ctrlDown(/* function args */);
extern DLLIMPORT /* return type */ AzKeyboardState_altDown(/* function args */);
extern DLLIMPORT /* return type */ AzKeyboardState_superDown(/* function args */);
extern DLLIMPORT /* return type */ AzKeyboardState_isKeyDown(/* function args */);


extern DLLIMPORT /* return type */ AzCursorPosition_getPosition(/* function args */);

















extern DLLIMPORT AzWindowState AzWindowState_new(/* function args */);
extern DLLIMPORT AzWindowState AzWindowState_default(/* function args */);









extern DLLIMPORT /* return type */ AzCallbackInfo_getHitNode(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getSystemTimeFn(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getCursorRelativeToViewport(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getCursorRelativeToNode(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getCurrentWindowState(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getCurrentKeyboardState(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getCurrentMouseState(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getPreviousWindowState(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getPreviousKeyboardState(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getPreviousMouseState(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getCurrentWindowHandle(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getGlContext(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getScrollPosition(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getDataset(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getNodeIdOfRootDataset(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getStringContents(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getInlineText(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getFontRef(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getTextLayoutOptions(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_shapeText(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getIndexInParent(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getParent(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getPreviousSibling(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getNextSibling(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getFirstChild(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getLastChild(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getNodePosition(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getNodeSize(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getComputedCssProperty(/* function args */);
extern DLLIMPORT void AzCallbackInfo_setWindowState(/* function args */);
extern DLLIMPORT void AzCallbackInfo_setFocus(/* function args */);
extern DLLIMPORT void AzCallbackInfo_setCssProperty(/* function args */);
extern DLLIMPORT void AzCallbackInfo_setScrollPosition(/* function args */);
extern DLLIMPORT void AzCallbackInfo_setStringContents(/* function args */);
extern DLLIMPORT void AzCallbackInfo_addImage(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_hasImage(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_getImage(/* function args */);
extern DLLIMPORT void AzCallbackInfo_updateImage(/* function args */);
extern DLLIMPORT void AzCallbackInfo_deleteImage(/* function args */);
extern DLLIMPORT void AzCallbackInfo_updateImageMask(/* function args */);
extern DLLIMPORT void AzCallbackInfo_stopPropagation(/* function args */);
extern DLLIMPORT void AzCallbackInfo_createWindow(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_startTimer(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_startAnimation(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_stopTimer(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_startThread(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_sendThreadMsg(/* function args */);
extern DLLIMPORT /* return type */ AzCallbackInfo_stopThread(/* function args */);






extern DLLIMPORT /* return type */ AzPositionInfo_isPositioned(/* function args */);
extern DLLIMPORT /* return type */ AzPositionInfo_getStaticOffset(/* function args */);
extern DLLIMPORT /* return type */ AzPositionInfo_getRelativeOffset(/* function args */);


extern DLLIMPORT /* return type */ AzHidpiAdjustedBounds_getLogicalSize(/* function args */);
extern DLLIMPORT /* return type */ AzHidpiAdjustedBounds_getPhysicalSize(/* function args */);
extern DLLIMPORT /* return type */ AzHidpiAdjustedBounds_getHidpiFactor(/* function args */);

extern DLLIMPORT /* return type */ AzInlineText_hitTest(/* function args */);









extern DLLIMPORT AzResolvedTextLayoutOptions AzResolvedTextLayoutOptions_default(/* function args */);











extern DLLIMPORT /* return type */ AzRenderImageCallbackInfo_getGlContext(/* function args */);
extern DLLIMPORT /* return type */ AzRenderImageCallbackInfo_getBounds(/* function args */);
extern DLLIMPORT /* return type */ AzRenderImageCallbackInfo_getCallbackNodeId(/* function args */);
extern DLLIMPORT /* return type */ AzRenderImageCallbackInfo_getInlineText(/* function args */);
extern DLLIMPORT /* return type */ AzRenderImageCallbackInfo_getIndexInParent(/* function args */);
extern DLLIMPORT /* return type */ AzRenderImageCallbackInfo_getParent(/* function args */);
extern DLLIMPORT /* return type */ AzRenderImageCallbackInfo_getPreviousSibling(/* function args */);
extern DLLIMPORT /* return type */ AzRenderImageCallbackInfo_getNextSibling(/* function args */);
extern DLLIMPORT /* return type */ AzRenderImageCallbackInfo_getFirstChild(/* function args */);
extern DLLIMPORT /* return type */ AzRenderImageCallbackInfo_getLastChild(/* function args */);










extern DLLIMPORT /* return type */ AzRefCount_canBeShared(/* function args */);
extern DLLIMPORT /* return type */ AzRefCount_canBeSharedMut(/* function args */);
extern DLLIMPORT void AzRefCount_increaseRef(/* function args */);
extern DLLIMPORT void AzRefCount_decreaseRef(/* function args */);
extern DLLIMPORT void AzRefCount_increaseRefmut(/* function args */);
extern DLLIMPORT void AzRefCount_decreaseRefmut(/* function args */);

extern DLLIMPORT AzRefAny AzRefAny_newC(/* function args */);
extern DLLIMPORT /* return type */ AzRefAny_getTypeId(/* function args */);
extern DLLIMPORT /* return type */ AzRefAny_getTypeName(/* function args */);

extern DLLIMPORT /* return type */ AzLayoutCallbackInfo_getGlContext(/* function args */);
extern DLLIMPORT /* return type */ AzLayoutCallbackInfo_getSystemFonts(/* function args */);
extern DLLIMPORT /* return type */ AzLayoutCallbackInfo_getImage(/* function args */);

extern DLLIMPORT AzDom AzDom_new(/* function args */);
extern DLLIMPORT AzDom AzDom_body(/* function args */);
extern DLLIMPORT AzDom AzDom_div(/* function args */);
extern DLLIMPORT AzDom AzDom_br(/* function args */);
extern DLLIMPORT AzDom AzDom_text(/* function args */);
extern DLLIMPORT AzDom AzDom_image(/* function args */);
extern DLLIMPORT AzDom AzDom_iframe(/* function args */);
extern DLLIMPORT void AzDom_setNodeType(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withNodeType(/* function args */);
extern DLLIMPORT void AzDom_setDataset(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withDataset(/* function args */);
extern DLLIMPORT void AzDom_setIdsAndClasses(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withIdsAndClasses(/* function args */);
extern DLLIMPORT void AzDom_setCallbacks(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withCallbacks(/* function args */);
extern DLLIMPORT void AzDom_setInlineCssProps(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withInlineCssProps(/* function args */);
extern DLLIMPORT void AzDom_addCallback(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withCallback(/* function args */);
extern DLLIMPORT void AzDom_addChild(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withChild(/* function args */);
extern DLLIMPORT void AzDom_setChildren(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withChildren(/* function args */);
extern DLLIMPORT void AzDom_addId(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withId(/* function args */);
extern DLLIMPORT void AzDom_addClass(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withClass(/* function args */);
extern DLLIMPORT void AzDom_addCssProperty(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withCssProperty(/* function args */);
extern DLLIMPORT void AzDom_addHoverCssProperty(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withHoverCssProperty(/* function args */);
extern DLLIMPORT void AzDom_addActiveCssProperty(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withActiveCssProperty(/* function args */);
extern DLLIMPORT void AzDom_addFocusCssProperty(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withFocusCssProperty(/* function args */);
extern DLLIMPORT void AzDom_setInlineStyle(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withInlineStyle(/* function args */);
extern DLLIMPORT void AzDom_setInlineHoverStyle(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withInlineHoverStyle(/* function args */);
extern DLLIMPORT void AzDom_setInlineActiveStyle(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withInlineActiveStyle(/* function args */);
extern DLLIMPORT void AzDom_setInlineFocusStyle(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withInlineFocusStyle(/* function args */);
extern DLLIMPORT void AzDom_setClipMask(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withClipMask(/* function args */);
extern DLLIMPORT void AzDom_setTabIndex(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withTabIndex(/* function args */);
extern DLLIMPORT void AzDom_setAccessibilityInfo(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withAccessibilityInfo(/* function args */);
extern DLLIMPORT void AzDom_setMenuBar(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withMenuBar(/* function args */);
extern DLLIMPORT void AzDom_setContextMenu(/* function args */);
extern DLLIMPORT /* return type */ AzDom_withContextMenu(/* function args */);
extern DLLIMPORT /* return type */ AzDom_hash(/* function args */);
extern DLLIMPORT /* return type */ AzDom_nodeCount(/* function args */);
extern DLLIMPORT /* return type */ AzDom_getHtmlString(/* function args */);
extern DLLIMPORT /* return type */ AzDom_getHtmlStringTest(/* function args */);
extern DLLIMPORT /* return type */ AzDom_style(/* function args */);



extern DLLIMPORT AzNodeData AzNodeData_new(/* function args */);
extern DLLIMPORT AzNodeData AzNodeData_body(/* function args */);
extern DLLIMPORT AzNodeData AzNodeData_div(/* function args */);
extern DLLIMPORT AzNodeData AzNodeData_br(/* function args */);
extern DLLIMPORT AzNodeData AzNodeData_text(/* function args */);
extern DLLIMPORT AzNodeData AzNodeData_image(/* function args */);
extern DLLIMPORT AzNodeData AzNodeData_iframe(/* function args */);
extern DLLIMPORT void AzNodeData_setNodeType(/* function args */);
extern DLLIMPORT /* return type */ AzNodeData_withNodeType(/* function args */);
extern DLLIMPORT void AzNodeData_setDataset(/* function args */);
extern DLLIMPORT /* return type */ AzNodeData_withDataset(/* function args */);
extern DLLIMPORT void AzNodeData_setIdsAndClasses(/* function args */);
extern DLLIMPORT /* return type */ AzNodeData_withIdsAndClasses(/* function args */);
extern DLLIMPORT void AzNodeData_addCallback(/* function args */);
extern DLLIMPORT /* return type */ AzNodeData_withCallback(/* function args */);
extern DLLIMPORT void AzNodeData_setCallbacks(/* function args */);
extern DLLIMPORT /* return type */ AzNodeData_withCallbacks(/* function args */);
extern DLLIMPORT void AzNodeData_setInlineCssProps(/* function args */);
extern DLLIMPORT /* return type */ AzNodeData_withInlineCssProps(/* function args */);
extern DLLIMPORT void AzNodeData_setInlineStyle(/* function args */);
extern DLLIMPORT /* return type */ AzNodeData_withInlineStyle(/* function args */);
extern DLLIMPORT void AzNodeData_setInlineHoverStyle(/* function args */);
extern DLLIMPORT /* return type */ AzNodeData_withInlineHoverStyle(/* function args */);
extern DLLIMPORT void AzNodeData_setInlineActiveStyle(/* function args */);
extern DLLIMPORT /* return type */ AzNodeData_withInlineActiveStyle(/* function args */);
extern DLLIMPORT void AzNodeData_setInlineFocusStyle(/* function args */);
extern DLLIMPORT /* return type */ AzNodeData_withInlineFocusStyle(/* function args */);
extern DLLIMPORT void AzNodeData_setClipMask(/* function args */);
extern DLLIMPORT void AzNodeData_setTabIndex(/* function args */);
extern DLLIMPORT void AzNodeData_setAccessibilityInfo(/* function args */);
extern DLLIMPORT void AzNodeData_setMenuBar(/* function args */);
extern DLLIMPORT void AzNodeData_setContextMenu(/* function args */);
extern DLLIMPORT /* return type */ AzNodeData_hash(/* function args */);


extern DLLIMPORT /* return type */ AzOn_intoEventFilter(/* function args */);














extern DLLIMPORT AzMenu AzMenu_new(/* function args */);
extern DLLIMPORT void AzMenu_setPopupPosition(/* function args */);
extern DLLIMPORT /* return type */ AzMenu_withPopupPosition(/* function args */);




extern DLLIMPORT AzStringMenuItem AzStringMenuItem_new(/* function args */);
extern DLLIMPORT void AzStringMenuItem_setCallback(/* function args */);
extern DLLIMPORT /* return type */ AzStringMenuItem_withCallback(/* function args */);
extern DLLIMPORT void AzStringMenuItem_addChild(/* function args */);
extern DLLIMPORT /* return type */ AzStringMenuItem_withChild(/* function args */);
extern DLLIMPORT void AzStringMenuItem_setChildren(/* function args */);
extern DLLIMPORT /* return type */ AzStringMenuItem_withChildren(/* function args */);


extern DLLIMPORT AzMenuCallback AzMenuCallback_new(/* function args */);











extern DLLIMPORT AzCss AzCss_empty(/* function args */);
extern DLLIMPORT AzCss AzCss_fromString(/* function args */);






extern DLLIMPORT AzColorU AzColorU_fromStr(/* function args */);
extern DLLIMPORT AzColorU AzColorU_transparent(/* function args */);
extern DLLIMPORT AzColorU AzColorU_white(/* function args */);
extern DLLIMPORT AzColorU AzColorU_black(/* function args */);
extern DLLIMPORT /* return type */ AzColorU_toHash(/* function args */);













































extern DLLIMPORT /* return type */ AzAngleValue_getDegrees(/* function args */);































































































































extern DLLIMPORT /* return type */ AzCssProperty_getKeyString(/* function args */);
extern DLLIMPORT /* return type */ AzCssProperty_getValueString(/* function args */);
extern DLLIMPORT /* return type */ AzCssProperty_getKeyValueString(/* function args */);
extern DLLIMPORT /* return type */ AzCssProperty_interpolate(/* function args */);

extern DLLIMPORT /* return type */ AzRibbon_dom(/* function args */);



extern DLLIMPORT AzButton AzButton_new(/* function args */);
extern DLLIMPORT void AzButton_setOnClick(/* function args */);
extern DLLIMPORT /* return type */ AzButton_withOnClick(/* function args */);
extern DLLIMPORT /* return type */ AzButton_dom(/* function args */);


extern DLLIMPORT AzFileInput AzFileInput_new(/* function args */);
extern DLLIMPORT void AzFileInput_setDefaultText(/* function args */);
extern DLLIMPORT /* return type */ AzFileInput_withDefaultText(/* function args */);
extern DLLIMPORT void AzFileInput_setOnPathChange(/* function args */);
extern DLLIMPORT /* return type */ AzFileInput_withOnPathChange(/* function args */);
extern DLLIMPORT /* return type */ AzFileInput_dom(/* function args */);






extern DLLIMPORT AzCheckBox AzCheckBox_new(/* function args */);
extern DLLIMPORT void AzCheckBox_setOnToggle(/* function args */);
extern DLLIMPORT /* return type */ AzCheckBox_withOnToggle(/* function args */);
extern DLLIMPORT /* return type */ AzCheckBox_dom(/* function args */);






extern DLLIMPORT AzLabel AzLabel_new(/* function args */);
extern DLLIMPORT /* return type */ AzLabel_dom(/* function args */);

extern DLLIMPORT AzColorInput AzColorInput_new(/* function args */);
extern DLLIMPORT void AzColorInput_setOnValueChange(/* function args */);
extern DLLIMPORT /* return type */ AzColorInput_withOnValueChange(/* function args */);
extern DLLIMPORT /* return type */ AzColorInput_dom(/* function args */);






extern DLLIMPORT AzTextInput AzTextInput_new(/* function args */);
extern DLLIMPORT void AzTextInput_setText(/* function args */);
extern DLLIMPORT /* return type */ AzTextInput_withText(/* function args */);
extern DLLIMPORT void AzTextInput_setPlaceholder(/* function args */);
extern DLLIMPORT /* return type */ AzTextInput_withPlaceholder(/* function args */);
extern DLLIMPORT void AzTextInput_setOnTextInput(/* function args */);
extern DLLIMPORT /* return type */ AzTextInput_withOnTextInput(/* function args */);
extern DLLIMPORT void AzTextInput_setOnVirtualKeyDown(/* function args */);
extern DLLIMPORT /* return type */ AzTextInput_withOnVirtualKeyDown(/* function args */);
extern DLLIMPORT void AzTextInput_setOnFocusLost(/* function args */);
extern DLLIMPORT /* return type */ AzTextInput_withOnFocusLost(/* function args */);
extern DLLIMPORT void AzTextInput_setPlaceholderStyle(/* function args */);
extern DLLIMPORT /* return type */ AzTextInput_withPlaceholderStyle(/* function args */);
extern DLLIMPORT void AzTextInput_setContainerStyle(/* function args */);
extern DLLIMPORT /* return type */ AzTextInput_withContainerStyle(/* function args */);
extern DLLIMPORT void AzTextInput_setLabelStyle(/* function args */);
extern DLLIMPORT /* return type */ AzTextInput_withLabelStyle(/* function args */);
extern DLLIMPORT /* return type */ AzTextInput_dom(/* function args */);


extern DLLIMPORT /* return type */ AzTextInputState_getText(/* function args */);














extern DLLIMPORT AzNumberInput AzNumberInput_new(/* function args */);
extern DLLIMPORT void AzNumberInput_setOnTextInput(/* function args */);
extern DLLIMPORT /* return type */ AzNumberInput_withOnTextInput(/* function args */);
extern DLLIMPORT void AzNumberInput_setOnVirtualKeyDown(/* function args */);
extern DLLIMPORT /* return type */ AzNumberInput_withOnVirtualKeyDown(/* function args */);
extern DLLIMPORT void AzNumberInput_setOnFocusLost(/* function args */);
extern DLLIMPORT /* return type */ AzNumberInput_withOnFocusLost(/* function args */);
extern DLLIMPORT void AzNumberInput_setPlaceholderStyle(/* function args */);
extern DLLIMPORT /* return type */ AzNumberInput_withPlaceholderStyle(/* function args */);
extern DLLIMPORT void AzNumberInput_setContainerStyle(/* function args */);
extern DLLIMPORT /* return type */ AzNumberInput_withContainerStyle(/* function args */);
extern DLLIMPORT void AzNumberInput_setLabelStyle(/* function args */);
extern DLLIMPORT /* return type */ AzNumberInput_withLabelStyle(/* function args */);
extern DLLIMPORT void AzNumberInput_setOnValueChange(/* function args */);
extern DLLIMPORT /* return type */ AzNumberInput_withOnValueChange(/* function args */);
extern DLLIMPORT /* return type */ AzNumberInput_dom(/* function args */);









extern DLLIMPORT AzProgressBar AzProgressBar_new(/* function args */);
extern DLLIMPORT void AzProgressBar_setHeight(/* function args */);
extern DLLIMPORT /* return type */ AzProgressBar_withHeight(/* function args */);
extern DLLIMPORT void AzProgressBar_setContainerBackground(/* function args */);
extern DLLIMPORT /* return type */ AzProgressBar_withContainerStyle(/* function args */);
extern DLLIMPORT void AzProgressBar_setBarBackground(/* function args */);
extern DLLIMPORT /* return type */ AzProgressBar_withBarBackground(/* function args */);
extern DLLIMPORT /* return type */ AzProgressBar_dom(/* function args */);


extern DLLIMPORT AzTabHeader AzTabHeader_new(/* function args */);
extern DLLIMPORT void AzTabHeader_setActiveTab(/* function args */);
extern DLLIMPORT /* return type */ AzTabHeader_withActiveTab(/* function args */);
extern DLLIMPORT void AzTabHeader_setOnClick(/* function args */);
extern DLLIMPORT /* return type */ AzTabHeader_withOnClick(/* function args */);
extern DLLIMPORT /* return type */ AzTabHeader_dom(/* function args */);


extern DLLIMPORT AzTabContent AzTabContent_new(/* function args */);
extern DLLIMPORT void AzTabContent_setPadding(/* function args */);
extern DLLIMPORT /* return type */ AzTabContent_withPadding(/* function args */);
extern DLLIMPORT /* return type */ AzTabContent_dom(/* function args */);




extern DLLIMPORT AzFrame AzFrame_new(/* function args */);
extern DLLIMPORT void AzFrame_setFlexGrow(/* function args */);
extern DLLIMPORT /* return type */ AzFrame_withFlexGrow(/* function args */);
extern DLLIMPORT /* return type */ AzFrame_dom(/* function args */);

extern DLLIMPORT /* return type */ AzNodeGraph_dom(/* function args */);













































extern DLLIMPORT AzListView AzListView_new(/* function args */);
extern DLLIMPORT /* return type */ AzListView_withRows(/* function args */);
extern DLLIMPORT /* return type */ AzListView_dom(/* function args */);












extern DLLIMPORT AzTreeView AzTreeView_new(/* function args */);
extern DLLIMPORT /* return type */ AzTreeView_dom(/* function args */);

extern DLLIMPORT AzDropDown AzDropDown_new(/* function args */);
extern DLLIMPORT /* return type */ AzDropDown_dom(/* function args */);













extern DLLIMPORT AzStyledDom AzStyledDom_new(/* function args */);
extern DLLIMPORT AzStyledDom AzStyledDom_default(/* function args */);
extern DLLIMPORT AzStyledDom AzStyledDom_fromXml(/* function args */);
extern DLLIMPORT AzStyledDom AzStyledDom_fromFile(/* function args */);
extern DLLIMPORT void AzStyledDom_appendChild(/* function args */);
extern DLLIMPORT /* return type */ AzStyledDom_withChild(/* function args */);
extern DLLIMPORT void AzStyledDom_restyle(/* function args */);
extern DLLIMPORT /* return type */ AzStyledDom_nodeCount(/* function args */);
extern DLLIMPORT /* return type */ AzStyledDom_getHtmlString(/* function args */);
extern DLLIMPORT /* return type */ AzStyledDom_getHtmlStringTest(/* function args */);
extern DLLIMPORT void AzStyledDom_setMenuBar(/* function args */);
extern DLLIMPORT /* return type */ AzStyledDom_withMenuBar(/* function args */);
extern DLLIMPORT void AzStyledDom_setContextMenu(/* function args */);
extern DLLIMPORT /* return type */ AzStyledDom_withContextMenu(/* function args */);

extern DLLIMPORT AzTexture AzTexture_new(/* function args */);
extern DLLIMPORT AzTexture AzTexture_allocateRgba8(/* function args */);
extern DLLIMPORT AzTexture AzTexture_allocateClipMask(/* function args */);
extern DLLIMPORT void AzTexture_clear(/* function args */);
extern DLLIMPORT /* return type */ AzTexture_drawClipMask(/* function args */);
extern DLLIMPORT /* return type */ AzTexture_drawTesselatedSvgGpuNode(/* function args */);
extern DLLIMPORT /* return type */ AzTexture_drawTesselatedColoredSvgGpuNode(/* function args */);
extern DLLIMPORT /* return type */ AzTexture_applyFxaa(/* function args */);



extern DLLIMPORT /* return type */ AzGl_getType(/* function args */);
extern DLLIMPORT void AzGl_bufferDataUntyped(/* function args */);
extern DLLIMPORT void AzGl_bufferSubDataUntyped(/* function args */);
extern DLLIMPORT /* return type */ AzGl_mapBuffer(/* function args */);
extern DLLIMPORT /* return type */ AzGl_mapBufferRange(/* function args */);
extern DLLIMPORT /* return type */ AzGl_unmapBuffer(/* function args */);
extern DLLIMPORT void AzGl_texBuffer(/* function args */);
extern DLLIMPORT void AzGl_shaderSource(/* function args */);
extern DLLIMPORT void AzGl_readBuffer(/* function args */);
extern DLLIMPORT void AzGl_readPixelsIntoBuffer(/* function args */);
extern DLLIMPORT /* return type */ AzGl_readPixels(/* function args */);
extern DLLIMPORT void AzGl_readPixelsIntoPbo(/* function args */);
extern DLLIMPORT void AzGl_sampleCoverage(/* function args */);
extern DLLIMPORT void AzGl_polygonOffset(/* function args */);
extern DLLIMPORT void AzGl_pixelStoreI(/* function args */);
extern DLLIMPORT /* return type */ AzGl_genBuffers(/* function args */);
extern DLLIMPORT /* return type */ AzGl_genRenderbuffers(/* function args */);
extern DLLIMPORT /* return type */ AzGl_genFramebuffers(/* function args */);
extern DLLIMPORT /* return type */ AzGl_genTextures(/* function args */);
extern DLLIMPORT /* return type */ AzGl_genVertexArrays(/* function args */);
extern DLLIMPORT /* return type */ AzGl_genQueries(/* function args */);
extern DLLIMPORT void AzGl_beginQuery(/* function args */);
extern DLLIMPORT void AzGl_endQuery(/* function args */);
extern DLLIMPORT void AzGl_queryCounter(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getQueryObjectIv(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getQueryObjectUiv(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getQueryObjectI64v(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getQueryObjectUi64v(/* function args */);
extern DLLIMPORT void AzGl_deleteQueries(/* function args */);
extern DLLIMPORT void AzGl_deleteVertexArrays(/* function args */);
extern DLLIMPORT void AzGl_deleteBuffers(/* function args */);
extern DLLIMPORT void AzGl_deleteRenderbuffers(/* function args */);
extern DLLIMPORT void AzGl_deleteFramebuffers(/* function args */);
extern DLLIMPORT void AzGl_deleteTextures(/* function args */);
extern DLLIMPORT void AzGl_framebufferRenderbuffer(/* function args */);
extern DLLIMPORT void AzGl_renderbufferStorage(/* function args */);
extern DLLIMPORT void AzGl_depthFunc(/* function args */);
extern DLLIMPORT void AzGl_activeTexture(/* function args */);
extern DLLIMPORT void AzGl_attachShader(/* function args */);
extern DLLIMPORT void AzGl_bindAttribLocation(/* function args */);
extern DLLIMPORT void AzGl_getUniformIv(/* function args */);
extern DLLIMPORT void AzGl_getUniformFv(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getUniformBlockIndex(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getUniformIndices(/* function args */);
extern DLLIMPORT void AzGl_bindBufferBase(/* function args */);
extern DLLIMPORT void AzGl_bindBufferRange(/* function args */);
extern DLLIMPORT void AzGl_uniformBlockBinding(/* function args */);
extern DLLIMPORT void AzGl_bindBuffer(/* function args */);
extern DLLIMPORT void AzGl_bindVertexArray(/* function args */);
extern DLLIMPORT void AzGl_bindRenderbuffer(/* function args */);
extern DLLIMPORT void AzGl_bindFramebuffer(/* function args */);
extern DLLIMPORT void AzGl_bindTexture(/* function args */);
extern DLLIMPORT void AzGl_drawBuffers(/* function args */);
extern DLLIMPORT void AzGl_texImage2d(/* function args */);
extern DLLIMPORT void AzGl_compressedTexImage2d(/* function args */);
extern DLLIMPORT void AzGl_compressedTexSubImage2d(/* function args */);
extern DLLIMPORT void AzGl_texImage3d(/* function args */);
extern DLLIMPORT void AzGl_copyTexImage2d(/* function args */);
extern DLLIMPORT void AzGl_copyTexSubImage2d(/* function args */);
extern DLLIMPORT void AzGl_copyTexSubImage3d(/* function args */);
extern DLLIMPORT void AzGl_texSubImage2d(/* function args */);
extern DLLIMPORT void AzGl_texSubImage2dPbo(/* function args */);
extern DLLIMPORT void AzGl_texSubImage3d(/* function args */);
extern DLLIMPORT void AzGl_texSubImage3dPbo(/* function args */);
extern DLLIMPORT void AzGl_texStorage2d(/* function args */);
extern DLLIMPORT void AzGl_texStorage3d(/* function args */);
extern DLLIMPORT void AzGl_getTexImageIntoBuffer(/* function args */);
extern DLLIMPORT void AzGl_copyImageSubData(/* function args */);
extern DLLIMPORT void AzGl_invalidateFramebuffer(/* function args */);
extern DLLIMPORT void AzGl_invalidateSubFramebuffer(/* function args */);
extern DLLIMPORT void AzGl_getIntegerV(/* function args */);
extern DLLIMPORT void AzGl_getInteger64v(/* function args */);
extern DLLIMPORT void AzGl_getIntegerIv(/* function args */);
extern DLLIMPORT void AzGl_getInteger64iv(/* function args */);
extern DLLIMPORT void AzGl_getBooleanV(/* function args */);
extern DLLIMPORT void AzGl_getFloatV(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getFramebufferAttachmentParameterIv(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getRenderbufferParameterIv(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getTexParameterIv(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getTexParameterFv(/* function args */);
extern DLLIMPORT void AzGl_texParameterI(/* function args */);
extern DLLIMPORT void AzGl_texParameterF(/* function args */);
extern DLLIMPORT void AzGl_framebufferTexture2d(/* function args */);
extern DLLIMPORT void AzGl_framebufferTextureLayer(/* function args */);
extern DLLIMPORT void AzGl_blitFramebuffer(/* function args */);
extern DLLIMPORT void AzGl_vertexAttrib4f(/* function args */);
extern DLLIMPORT void AzGl_vertexAttribPointerF32(/* function args */);
extern DLLIMPORT void AzGl_vertexAttribPointer(/* function args */);
extern DLLIMPORT void AzGl_vertexAttribIPointer(/* function args */);
extern DLLIMPORT void AzGl_vertexAttribDivisor(/* function args */);
extern DLLIMPORT void AzGl_viewport(/* function args */);
extern DLLIMPORT void AzGl_scissor(/* function args */);
extern DLLIMPORT void AzGl_lineWidth(/* function args */);
extern DLLIMPORT void AzGl_useProgram(/* function args */);
extern DLLIMPORT void AzGl_validateProgram(/* function args */);
extern DLLIMPORT void AzGl_drawArrays(/* function args */);
extern DLLIMPORT void AzGl_drawArraysInstanced(/* function args */);
extern DLLIMPORT void AzGl_drawElements(/* function args */);
extern DLLIMPORT void AzGl_drawElementsInstanced(/* function args */);
extern DLLIMPORT void AzGl_blendColor(/* function args */);
extern DLLIMPORT void AzGl_blendFunc(/* function args */);
extern DLLIMPORT void AzGl_blendFuncSeparate(/* function args */);
extern DLLIMPORT void AzGl_blendEquation(/* function args */);
extern DLLIMPORT void AzGl_blendEquationSeparate(/* function args */);
extern DLLIMPORT void AzGl_colorMask(/* function args */);
extern DLLIMPORT void AzGl_cullFace(/* function args */);
extern DLLIMPORT void AzGl_frontFace(/* function args */);
extern DLLIMPORT void AzGl_enable(/* function args */);
extern DLLIMPORT void AzGl_disable(/* function args */);
extern DLLIMPORT void AzGl_hint(/* function args */);
extern DLLIMPORT /* return type */ AzGl_isEnabled(/* function args */);
extern DLLIMPORT /* return type */ AzGl_isShader(/* function args */);
extern DLLIMPORT /* return type */ AzGl_isTexture(/* function args */);
extern DLLIMPORT /* return type */ AzGl_isFramebuffer(/* function args */);
extern DLLIMPORT /* return type */ AzGl_isRenderbuffer(/* function args */);
extern DLLIMPORT /* return type */ AzGl_checkFrameBufferStatus(/* function args */);
extern DLLIMPORT void AzGl_enableVertexAttribArray(/* function args */);
extern DLLIMPORT void AzGl_disableVertexAttribArray(/* function args */);
extern DLLIMPORT void AzGl_uniform1f(/* function args */);
extern DLLIMPORT void AzGl_uniform1fv(/* function args */);
extern DLLIMPORT void AzGl_uniform1i(/* function args */);
extern DLLIMPORT void AzGl_uniform1iv(/* function args */);
extern DLLIMPORT void AzGl_uniform1ui(/* function args */);
extern DLLIMPORT void AzGl_uniform2f(/* function args */);
extern DLLIMPORT void AzGl_uniform2fv(/* function args */);
extern DLLIMPORT void AzGl_uniform2i(/* function args */);
extern DLLIMPORT void AzGl_uniform2iv(/* function args */);
extern DLLIMPORT void AzGl_uniform2ui(/* function args */);
extern DLLIMPORT void AzGl_uniform3f(/* function args */);
extern DLLIMPORT void AzGl_uniform3fv(/* function args */);
extern DLLIMPORT void AzGl_uniform3i(/* function args */);
extern DLLIMPORT void AzGl_uniform3iv(/* function args */);
extern DLLIMPORT void AzGl_uniform3ui(/* function args */);
extern DLLIMPORT void AzGl_uniform4f(/* function args */);
extern DLLIMPORT void AzGl_uniform4i(/* function args */);
extern DLLIMPORT void AzGl_uniform4iv(/* function args */);
extern DLLIMPORT void AzGl_uniform4ui(/* function args */);
extern DLLIMPORT void AzGl_uniform4fv(/* function args */);
extern DLLIMPORT void AzGl_uniformMatrix2fv(/* function args */);
extern DLLIMPORT void AzGl_uniformMatrix3fv(/* function args */);
extern DLLIMPORT void AzGl_uniformMatrix4fv(/* function args */);
extern DLLIMPORT void AzGl_depthMask(/* function args */);
extern DLLIMPORT void AzGl_depthRange(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getActiveAttrib(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getActiveUniform(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getActiveUniformsIv(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getActiveUniformBlockI(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getActiveUniformBlockIv(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getActiveUniformBlockName(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getAttribLocation(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getFragDataLocation(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getUniformLocation(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getProgramInfoLog(/* function args */);
extern DLLIMPORT void AzGl_getProgramIv(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getProgramBinary(/* function args */);
extern DLLIMPORT void AzGl_programBinary(/* function args */);
extern DLLIMPORT void AzGl_programParameterI(/* function args */);
extern DLLIMPORT void AzGl_getVertexAttribIv(/* function args */);
extern DLLIMPORT void AzGl_getVertexAttribFv(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getVertexAttribPointerV(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getBufferParameterIv(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getShaderInfoLog(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getString(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getStringI(/* function args */);
extern DLLIMPORT void AzGl_getShaderIv(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getShaderPrecisionFormat(/* function args */);
extern DLLIMPORT void AzGl_compileShader(/* function args */);
extern DLLIMPORT /* return type */ AzGl_createProgram(/* function args */);
extern DLLIMPORT void AzGl_deleteProgram(/* function args */);
extern DLLIMPORT /* return type */ AzGl_createShader(/* function args */);
extern DLLIMPORT void AzGl_deleteShader(/* function args */);
extern DLLIMPORT void AzGl_detachShader(/* function args */);
extern DLLIMPORT void AzGl_linkProgram(/* function args */);
extern DLLIMPORT void AzGl_clearColor(/* function args */);
extern DLLIMPORT void AzGl_clear(/* function args */);
extern DLLIMPORT void AzGl_clearDepth(/* function args */);
extern DLLIMPORT void AzGl_clearStencil(/* function args */);
extern DLLIMPORT void AzGl_flush(/* function args */);
extern DLLIMPORT void AzGl_finish(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getError(/* function args */);
extern DLLIMPORT void AzGl_stencilMask(/* function args */);
extern DLLIMPORT void AzGl_stencilMaskSeparate(/* function args */);
extern DLLIMPORT void AzGl_stencilFunc(/* function args */);
extern DLLIMPORT void AzGl_stencilFuncSeparate(/* function args */);
extern DLLIMPORT void AzGl_stencilOp(/* function args */);
extern DLLIMPORT void AzGl_stencilOpSeparate(/* function args */);
extern DLLIMPORT void AzGl_eglImageTargetTexture2dOes(/* function args */);
extern DLLIMPORT void AzGl_generateMipmap(/* function args */);
extern DLLIMPORT void AzGl_insertEventMarkerExt(/* function args */);
extern DLLIMPORT void AzGl_pushGroupMarkerExt(/* function args */);
extern DLLIMPORT void AzGl_popGroupMarkerExt(/* function args */);
extern DLLIMPORT void AzGl_debugMessageInsertKhr(/* function args */);
extern DLLIMPORT void AzGl_pushDebugGroupKhr(/* function args */);
extern DLLIMPORT void AzGl_popDebugGroupKhr(/* function args */);
extern DLLIMPORT /* return type */ AzGl_fenceSync(/* function args */);
extern DLLIMPORT /* return type */ AzGl_clientWaitSync(/* function args */);
extern DLLIMPORT void AzGl_waitSync(/* function args */);
extern DLLIMPORT void AzGl_deleteSync(/* function args */);
extern DLLIMPORT void AzGl_textureRangeApple(/* function args */);
extern DLLIMPORT /* return type */ AzGl_genFencesApple(/* function args */);
extern DLLIMPORT void AzGl_deleteFencesApple(/* function args */);
extern DLLIMPORT void AzGl_setFenceApple(/* function args */);
extern DLLIMPORT void AzGl_finishFenceApple(/* function args */);
extern DLLIMPORT void AzGl_testFenceApple(/* function args */);
extern DLLIMPORT /* return type */ AzGl_testObjectApple(/* function args */);
extern DLLIMPORT void AzGl_finishObjectApple(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getFragDataIndex(/* function args */);
extern DLLIMPORT void AzGl_blendBarrierKhr(/* function args */);
extern DLLIMPORT void AzGl_bindFragDataLocationIndexed(/* function args */);
extern DLLIMPORT /* return type */ AzGl_getDebugMessages(/* function args */);
extern DLLIMPORT void AzGl_provokingVertexAngle(/* function args */);
extern DLLIMPORT /* return type */ AzGl_genVertexArraysApple(/* function args */);
extern DLLIMPORT void AzGl_bindVertexArrayApple(/* function args */);
extern DLLIMPORT void AzGl_deleteVertexArraysApple(/* function args */);
extern DLLIMPORT void AzGl_copyTextureChromium(/* function args */);
extern DLLIMPORT void AzGl_copySubTextureChromium(/* function args */);
extern DLLIMPORT void AzGl_eglImageTargetRenderbufferStorageOes(/* function args */);
extern DLLIMPORT void AzGl_copyTexture3dAngle(/* function args */);
extern DLLIMPORT void AzGl_copySubTexture3dAngle(/* function args */);
extern DLLIMPORT void AzGl_bufferStorage(/* function args */);
extern DLLIMPORT void AzGl_flushMappedBufferRange(/* function args */);





extern DLLIMPORT AzVertexArrayObject AzVertexArrayObject_new(/* function args */);


extern DLLIMPORT AzVertexBuffer AzVertexBuffer_new(/* function args */);



















extern DLLIMPORT AzTextureFlags AzTextureFlags_default(/* function args */);

extern DLLIMPORT AzImageRef AzImageRef_nullImage(/* function args */);
extern DLLIMPORT AzImageRef AzImageRef_rawImage(/* function args */);
extern DLLIMPORT AzImageRef AzImageRef_glTexture(/* function args */);
extern DLLIMPORT AzImageRef AzImageRef_callback(/* function args */);
extern DLLIMPORT /* return type */ AzImageRef_cloneBytes(/* function args */);
extern DLLIMPORT /* return type */ AzImageRef_isInvalid(/* function args */);
extern DLLIMPORT /* return type */ AzImageRef_isGlTexture(/* function args */);
extern DLLIMPORT /* return type */ AzImageRef_isRawImage(/* function args */);
extern DLLIMPORT /* return type */ AzImageRef_isCallback(/* function args */);
extern DLLIMPORT /* return type */ AzImageRef_getRawImage(/* function args */);
extern DLLIMPORT /* return type */ AzImageRef_getHash(/* function args */);

extern DLLIMPORT AzRawImage AzRawImage_empty(/* function args */);
extern DLLIMPORT AzRawImage AzRawImage_allocateClipMask(/* function args */);
extern DLLIMPORT AzRawImage AzRawImage_decodeImageBytesAny(/* function args */);
extern DLLIMPORT /* return type */ AzRawImage_drawClipMask(/* function args */);
extern DLLIMPORT /* return type */ AzRawImage_encodeBmp(/* function args */);
extern DLLIMPORT /* return type */ AzRawImage_encodePng(/* function args */);
extern DLLIMPORT /* return type */ AzRawImage_encodeJpeg(/* function args */);
extern DLLIMPORT /* return type */ AzRawImage_encodeTga(/* function args */);
extern DLLIMPORT /* return type */ AzRawImage_encodePnm(/* function args */);
extern DLLIMPORT /* return type */ AzRawImage_encodeGif(/* function args */);
extern DLLIMPORT /* return type */ AzRawImage_encodeTiff(/* function args */);







extern DLLIMPORT AzFontMetrics AzFontMetrics_zero(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_useTypoMetrics(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getAscender(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getDescender(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getLineGap(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getXMin(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getYMin(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getXMax(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getYMax(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getAdvanceWidthMax(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getMinLeftSideBearing(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getMinRightSideBearing(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getXMaxExtent(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getXAvgCharWidth(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getYSubscriptXSize(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getYSubscriptYSize(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getYSubscriptXOffset(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getYSubscriptYOffset(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getYSuperscriptXSize(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getYSuperscriptYSize(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getYSuperscriptXOffset(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getYSuperscriptYOffset(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getYStrikeoutSize(/* function args */);
extern DLLIMPORT /* return type */ AzFontMetrics_getYStrikeoutPosition(/* function args */);


extern DLLIMPORT AzFontRef AzFontRef_parse(/* function args */);
extern DLLIMPORT /* return type */ AzFontRef_getBytes(/* function args */);
extern DLLIMPORT /* return type */ AzFontRef_getFontMetrics(/* function args */);
extern DLLIMPORT /* return type */ AzFontRef_shapeText(/* function args */);
extern DLLIMPORT /* return type */ AzFontRef_getHash(/* function args */);

extern DLLIMPORT AzSvg AzSvg_fromString(/* function args */);
extern DLLIMPORT AzSvg AzSvg_fromBytes(/* function args */);
extern DLLIMPORT /* return type */ AzSvg_getRoot(/* function args */);
extern DLLIMPORT /* return type */ AzSvg_render(/* function args */);
extern DLLIMPORT /* return type */ AzSvg_toString(/* function args */);

extern DLLIMPORT AzSvgXmlNode AzSvgXmlNode_parseFrom(/* function args */);

extern DLLIMPORT /* return type */ AzSvgMultiPolygon_getBounds(/* function args */);
extern DLLIMPORT /* return type */ AzSvgMultiPolygon_containsPoint(/* function args */);
extern DLLIMPORT /* return type */ AzSvgMultiPolygon_union(/* function args */);
extern DLLIMPORT /* return type */ AzSvgMultiPolygon_intersection(/* function args */);
extern DLLIMPORT /* return type */ AzSvgMultiPolygon_difference(/* function args */);
extern DLLIMPORT /* return type */ AzSvgMultiPolygon_xor(/* function args */);
extern DLLIMPORT /* return type */ AzSvgMultiPolygon_tessellateFill(/* function args */);
extern DLLIMPORT /* return type */ AzSvgMultiPolygon_tessellateStroke(/* function args */);

extern DLLIMPORT /* return type */ AzSvgNode_tessellateFill(/* function args */);
extern DLLIMPORT /* return type */ AzSvgNode_tessellateStroke(/* function args */);
extern DLLIMPORT /* return type */ AzSvgNode_isClosed(/* function args */);
extern DLLIMPORT /* return type */ AzSvgNode_containsPoint(/* function args */);
extern DLLIMPORT /* return type */ AzSvgNode_getBounds(/* function args */);

extern DLLIMPORT /* return type */ AzSvgSimpleNode_getBounds(/* function args */);

extern DLLIMPORT /* return type */ AzSvgStyledNode_tessellate(/* function args */);

extern DLLIMPORT /* return type */ AzSvgCircle_tessellateFill(/* function args */);
extern DLLIMPORT /* return type */ AzSvgCircle_tessellateStroke(/* function args */);

extern DLLIMPORT /* return type */ AzSvgPath_isClosed(/* function args */);
extern DLLIMPORT void AzSvgPath_reverse(/* function args */);
extern DLLIMPORT /* return type */ AzSvgPath_getStart(/* function args */);
extern DLLIMPORT /* return type */ AzSvgPath_getEnd(/* function args */);
extern DLLIMPORT /* return type */ AzSvgPath_getBounds(/* function args */);
extern DLLIMPORT void AzSvgPath_joinWith(/* function args */);
extern DLLIMPORT /* return type */ AzSvgPath_offset(/* function args */);
extern DLLIMPORT /* return type */ AzSvgPath_bevel(/* function args */);
extern DLLIMPORT /* return type */ AzSvgPath_tessellateFill(/* function args */);
extern DLLIMPORT /* return type */ AzSvgPath_tessellateStroke(/* function args */);

extern DLLIMPORT void AzSvgPathElement_reverse(/* function args */);
extern DLLIMPORT /* return type */ AzSvgPathElement_getStart(/* function args */);
extern DLLIMPORT /* return type */ AzSvgPathElement_getEnd(/* function args */);
extern DLLIMPORT /* return type */ AzSvgPathElement_getBounds(/* function args */);
extern DLLIMPORT /* return type */ AzSvgPathElement_getLength(/* function args */);
extern DLLIMPORT /* return type */ AzSvgPathElement_getTAtOffset(/* function args */);
extern DLLIMPORT /* return type */ AzSvgPathElement_getXAtT(/* function args */);
extern DLLIMPORT /* return type */ AzSvgPathElement_getYAtT(/* function args */);
extern DLLIMPORT /* return type */ AzSvgPathElement_getTangentVectorAtT(/* function args */);
extern DLLIMPORT /* return type */ AzSvgPathElement_tessellateStroke(/* function args */);

extern DLLIMPORT /* return type */ AzSvgPoint_distance(/* function args */);

extern DLLIMPORT /* return type */ AzSvgVector_angleDegrees(/* function args */);
extern DLLIMPORT /* return type */ AzSvgVector_normalize(/* function args */);
extern DLLIMPORT /* return type */ AzSvgVector_rotate90degCcw(/* function args */);

extern DLLIMPORT void AzSvgLine_reverse(/* function args */);
extern DLLIMPORT /* return type */ AzSvgLine_getStart(/* function args */);
extern DLLIMPORT /* return type */ AzSvgLine_getEnd(/* function args */);
extern DLLIMPORT /* return type */ AzSvgLine_getBounds(/* function args */);
extern DLLIMPORT /* return type */ AzSvgLine_getLength(/* function args */);
extern DLLIMPORT /* return type */ AzSvgLine_getTAtOffset(/* function args */);
extern DLLIMPORT /* return type */ AzSvgLine_getXAtT(/* function args */);
extern DLLIMPORT /* return type */ AzSvgLine_getYAtT(/* function args */);
extern DLLIMPORT /* return type */ AzSvgLine_getTangentVectorAtT(/* function args */);
extern DLLIMPORT /* return type */ AzSvgLine_intersect(/* function args */);
extern DLLIMPORT /* return type */ AzSvgLine_tessellateStroke(/* function args */);

extern DLLIMPORT void AzSvgQuadraticCurve_reverse(/* function args */);
extern DLLIMPORT /* return type */ AzSvgQuadraticCurve_getStart(/* function args */);
extern DLLIMPORT /* return type */ AzSvgQuadraticCurve_getEnd(/* function args */);
extern DLLIMPORT /* return type */ AzSvgQuadraticCurve_getBounds(/* function args */);
extern DLLIMPORT /* return type */ AzSvgQuadraticCurve_getLength(/* function args */);
extern DLLIMPORT /* return type */ AzSvgQuadraticCurve_getTAtOffset(/* function args */);
extern DLLIMPORT /* return type */ AzSvgQuadraticCurve_getXAtT(/* function args */);
extern DLLIMPORT /* return type */ AzSvgQuadraticCurve_getYAtT(/* function args */);
extern DLLIMPORT /* return type */ AzSvgQuadraticCurve_getTangentVectorAtT(/* function args */);
extern DLLIMPORT /* return type */ AzSvgQuadraticCurve_tessellateStroke(/* function args */);

extern DLLIMPORT void AzSvgCubicCurve_reverse(/* function args */);
extern DLLIMPORT /* return type */ AzSvgCubicCurve_getStart(/* function args */);
extern DLLIMPORT /* return type */ AzSvgCubicCurve_getEnd(/* function args */);
extern DLLIMPORT /* return type */ AzSvgCubicCurve_getBounds(/* function args */);
extern DLLIMPORT /* return type */ AzSvgCubicCurve_getLength(/* function args */);
extern DLLIMPORT /* return type */ AzSvgCubicCurve_getTAtOffset(/* function args */);
extern DLLIMPORT /* return type */ AzSvgCubicCurve_getXAtT(/* function args */);
extern DLLIMPORT /* return type */ AzSvgCubicCurve_getYAtT(/* function args */);
extern DLLIMPORT /* return type */ AzSvgCubicCurve_getTangentVectorAtT(/* function args */);
extern DLLIMPORT /* return type */ AzSvgCubicCurve_tessellateStroke(/* function args */);

extern DLLIMPORT /* return type */ AzSvgRect_getCenter(/* function args */);
extern DLLIMPORT /* return type */ AzSvgRect_containsPoint(/* function args */);
extern DLLIMPORT /* return type */ AzSvgRect_expand(/* function args */);
extern DLLIMPORT /* return type */ AzSvgRect_tessellateFill(/* function args */);
extern DLLIMPORT /* return type */ AzSvgRect_tessellateStroke(/* function args */);


extern DLLIMPORT AzTessellatedColoredSvgNode AzTessellatedColoredSvgNode_empty(/* function args */);
extern DLLIMPORT AzTessellatedColoredSvgNode AzTessellatedColoredSvgNode_fromNodes(/* function args */);


extern DLLIMPORT AzTessellatedColoredGPUSvgNode AzTessellatedColoredGPUSvgNode_new(/* function args */);


extern DLLIMPORT AzTessellatedSvgNode AzTessellatedSvgNode_empty(/* function args */);
extern DLLIMPORT AzTessellatedSvgNode AzTessellatedSvgNode_fromNodes(/* function args */);


extern DLLIMPORT AzTessellatedGPUSvgNode AzTessellatedGPUSvgNode_new(/* function args */);

extern DLLIMPORT AzSvgParseOptions AzSvgParseOptions_default(/* function args */);





extern DLLIMPORT AzSvgRenderOptions AzSvgRenderOptions_default(/* function args */);








extern DLLIMPORT AzSvgFillStyle AzSvgFillStyle_default(/* function args */);

extern DLLIMPORT AzSvgStrokeStyle AzSvgStrokeStyle_default(/* function args */);




extern DLLIMPORT AzXml AzXml_fromStr(/* function args */);


extern DLLIMPORT AzFile AzFile_open(/* function args */);
extern DLLIMPORT AzFile AzFile_create(/* function args */);
extern DLLIMPORT /* return type */ AzFile_readToString(/* function args */);
extern DLLIMPORT /* return type */ AzFile_readToBytes(/* function args */);
extern DLLIMPORT /* return type */ AzFile_writeString(/* function args */);
extern DLLIMPORT /* return type */ AzFile_writeBytes(/* function args */);
extern DLLIMPORT void AzFile_close(/* function args */);

extern DLLIMPORT AzMsgBox AzMsgBox_ok(/* function args */);
extern DLLIMPORT AzMsgBox AzMsgBox_info(/* function args */);
extern DLLIMPORT AzMsgBox AzMsgBox_warning(/* function args */);
extern DLLIMPORT AzMsgBox AzMsgBox_error(/* function args */);
extern DLLIMPORT AzMsgBox AzMsgBox_question(/* function args */);
extern DLLIMPORT AzMsgBox AzMsgBox_okCancel(/* function args */);
extern DLLIMPORT AzMsgBox AzMsgBox_yesNo(/* function args */);




extern DLLIMPORT AzFileDialog AzFileDialog_selectFile(/* function args */);
extern DLLIMPORT AzFileDialog AzFileDialog_selectMultipleFiles(/* function args */);
extern DLLIMPORT AzFileDialog AzFileDialog_selectFolder(/* function args */);
extern DLLIMPORT AzFileDialog AzFileDialog_saveFile(/* function args */);


extern DLLIMPORT AzColorPickerDialog AzColorPickerDialog_open(/* function args */);

extern DLLIMPORT AzSystemClipboard AzSystemClipboard_new(/* function args */);
extern DLLIMPORT /* return type */ AzSystemClipboard_getStringContents(/* function args */);
extern DLLIMPORT /* return type */ AzSystemClipboard_setStringContents(/* function args */);

extern DLLIMPORT /* return type */ AzInstant_durationSince(/* function args */);
extern DLLIMPORT /* return type */ AzInstant_addDuration(/* function args */);
extern DLLIMPORT /* return type */ AzInstant_linearInterpolate(/* function args */);











extern DLLIMPORT AzTimer AzTimer_new(/* function args */);
extern DLLIMPORT /* return type */ AzTimer_withDelay(/* function args */);
extern DLLIMPORT /* return type */ AzTimer_withInterval(/* function args */);
extern DLLIMPORT /* return type */ AzTimer_withTimeout(/* function args */);




extern DLLIMPORT /* return type */ AzThreadSender_send(/* function args */);

extern DLLIMPORT /* return type */ AzThreadReceiver_receive(/* function args */);


























extern DLLIMPORT AzString AzString_format(/* function args */);
extern DLLIMPORT AzString AzString_copyFromBytes(/* function args */);
extern DLLIMPORT /* return type */ AzString_trim(/* function args */);
extern DLLIMPORT /* return type */ AzString_asRefstr(/* function args */);















extern DLLIMPORT /* return type */ AzTessellatedSvgNodeVec_asRefVec(/* function args */);

extern DLLIMPORT /* return type */ AzTessellatedColoredSvgNodeVec_asRefVec(/* function args */);





































extern DLLIMPORT AzU8Vec AzU8Vec_copyFromBytes(/* function args */);
extern DLLIMPORT /* return type */ AzU8Vec_asRefVec(/* function args */);




































































































































































































































































/* CONSTANTS */

#define AzGl_ACCUM 0x0100
#define AzGl_ACCUM_ALPHA_BITS 0x0D5B
#define AzGl_ACCUM_BLUE_BITS 0x0D5A
#define AzGl_ACCUM_BUFFER_BIT 0x00000200
#define AzGl_ACCUM_CLEAR_VALUE 0x0B80
#define AzGl_ACCUM_GREEN_BITS 0x0D59
#define AzGl_ACCUM_RED_BITS 0x0D58
#define AzGl_ACTIVE_ATTRIBUTES 0x8B89
#define AzGl_ACTIVE_ATTRIBUTE_MAX_LENGTH 0x8B8A
#define AzGl_ACTIVE_TEXTURE 0x84E0
#define AzGl_ACTIVE_UNIFORMS 0x8B86
#define AzGl_ACTIVE_UNIFORM_BLOCKS 0x8A36
#define AzGl_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH 0x8A35
#define AzGl_ACTIVE_UNIFORM_MAX_LENGTH 0x8B87
#define AzGl_ADD 0x0104
#define AzGl_ADD_SIGNED 0x8574
#define AzGl_ALIASED_LINE_WIDTH_RANGE 0x846E
#define AzGl_ALIASED_POINT_SIZE_RANGE 0x846D
#define AzGl_ALL_ATTRIB_BITS 0xFFFFFFFF
#define AzGl_ALPHA 0x1906
#define AzGl_ALPHA12 0x803D
#define AzGl_ALPHA16 0x803E
#define AzGl_ALPHA16F_EXT 0x881C
#define AzGl_ALPHA32F_EXT 0x8816
#define AzGl_ALPHA4 0x803B
#define AzGl_ALPHA8 0x803C
#define AzGl_ALPHA8_EXT 0x803C
#define AzGl_ALPHA_BIAS 0x0D1D
#define AzGl_ALPHA_BITS 0x0D55
#define AzGl_ALPHA_INTEGER 0x8D97
#define AzGl_ALPHA_SCALE 0x0D1C
#define AzGl_ALPHA_TEST 0x0BC0
#define AzGl_ALPHA_TEST_FUNC 0x0BC1
#define AzGl_ALPHA_TEST_REF 0x0BC2
#define AzGl_ALREADY_SIGNALED 0x911A
#define AzGl_ALWAYS 0x0207
#define AzGl_AMBIENT 0x1200
#define AzGl_AMBIENT_AND_DIFFUSE 0x1602
#define AzGl_AND 0x1501
#define AzGl_AND_INVERTED 0x1504
#define AzGl_AND_REVERSE 0x1502
#define AzGl_ANY_SAMPLES_PASSED 0x8C2F
#define AzGl_ANY_SAMPLES_PASSED_CONSERVATIVE 0x8D6A
#define AzGl_ARRAY_BUFFER 0x8892
#define AzGl_ARRAY_BUFFER_BINDING 0x8894
#define AzGl_ATTACHED_SHADERS 0x8B85
#define AzGl_ATTRIB_STACK_DEPTH 0x0BB0
#define AzGl_AUTO_NORMAL 0x0D80
#define AzGl_AUX0 0x0409
#define AzGl_AUX1 0x040A
#define AzGl_AUX2 0x040B
#define AzGl_AUX3 0x040C
#define AzGl_AUX_BUFFERS 0x0C00
#define AzGl_BACK 0x0405
#define AzGl_BACK_LEFT 0x0402
#define AzGl_BACK_RIGHT 0x0403
#define AzGl_BGR 0x80E0
#define AzGl_BGRA 0x80E1
#define AzGl_BGRA8_EXT 0x93A1
#define AzGl_BGRA_EXT 0x80E1
#define AzGl_BGRA_INTEGER 0x8D9B
#define AzGl_BGR_INTEGER 0x8D9A
#define AzGl_BITMAP 0x1A00
#define AzGl_BITMAP_TOKEN 0x0704
#define AzGl_BLEND 0x0BE2
#define AzGl_BLEND_ADVANCED_COHERENT_KHR 0x9285
#define AzGl_BLEND_COLOR 0x8005
#define AzGl_BLEND_DST 0x0BE0
#define AzGl_BLEND_DST_ALPHA 0x80CA
#define AzGl_BLEND_DST_RGB 0x80C8
#define AzGl_BLEND_EQUATION 0x8009
#define AzGl_BLEND_EQUATION_ALPHA 0x883D
#define AzGl_BLEND_EQUATION_RGB 0x8009
#define AzGl_BLEND_SRC 0x0BE1
#define AzGl_BLEND_SRC_ALPHA 0x80CB
#define AzGl_BLEND_SRC_RGB 0x80C9
#define AzGl_BLUE 0x1905
#define AzGl_BLUE_BIAS 0x0D1B
#define AzGl_BLUE_BITS 0x0D54
#define AzGl_BLUE_INTEGER 0x8D96
#define AzGl_BLUE_SCALE 0x0D1A
#define AzGl_BOOL 0x8B56
#define AzGl_BOOL_VEC2 0x8B57
#define AzGl_BOOL_VEC3 0x8B58
#define AzGl_BOOL_VEC4 0x8B59
#define AzGl_BUFFER 0x82E0
#define AzGl_BUFFER_ACCESS 0x88BB
#define AzGl_BUFFER_ACCESS_FLAGS 0x911F
#define AzGl_BUFFER_KHR 0x82E0
#define AzGl_BUFFER_MAPPED 0x88BC
#define AzGl_BUFFER_MAP_LENGTH 0x9120
#define AzGl_BUFFER_MAP_OFFSET 0x9121
#define AzGl_BUFFER_MAP_POINTER 0x88BD
#define AzGl_BUFFER_SIZE 0x8764
#define AzGl_BUFFER_USAGE 0x8765
#define AzGl_BYTE 0x1400
#define AzGl_C3F_V3F 0x2A24
#define AzGl_C4F_N3F_V3F 0x2A26
#define AzGl_C4UB_V2F 0x2A22
#define AzGl_C4UB_V3F 0x2A23
#define AzGl_CCW 0x0901
#define AzGl_CLAMP 0x2900
#define AzGl_CLAMP_FRAGMENT_COLOR 0x891B
#define AzGl_CLAMP_READ_COLOR 0x891C
#define AzGl_CLAMP_TO_BORDER 0x812D
#define AzGl_CLAMP_TO_EDGE 0x812F
#define AzGl_CLAMP_VERTEX_COLOR 0x891A
#define AzGl_CLEAR 0x1500
#define AzGl_CLIENT_ACTIVE_TEXTURE 0x84E1
#define AzGl_CLIENT_ALL_ATTRIB_BITS 0xFFFFFFFF
#define AzGl_CLIENT_ATTRIB_STACK_DEPTH 0x0BB1
#define AzGl_CLIENT_PIXEL_STORE_BIT 0x00000001
#define AzGl_CLIENT_VERTEX_ARRAY_BIT 0x00000002
#define AzGl_CLIP_DISTANCE0 0x3000
#define AzGl_CLIP_DISTANCE1 0x3001
#define AzGl_CLIP_DISTANCE2 0x3002
#define AzGl_CLIP_DISTANCE3 0x3003
#define AzGl_CLIP_DISTANCE4 0x3004
#define AzGl_CLIP_DISTANCE5 0x3005
#define AzGl_CLIP_DISTANCE6 0x3006
#define AzGl_CLIP_DISTANCE7 0x3007
#define AzGl_CLIP_PLANE0 0x3000
#define AzGl_CLIP_PLANE1 0x3001
#define AzGl_CLIP_PLANE2 0x3002
#define AzGl_CLIP_PLANE3 0x3003
#define AzGl_CLIP_PLANE4 0x3004
#define AzGl_CLIP_PLANE5 0x3005
#define AzGl_COEFF 0x0A00
#define AzGl_COLOR 0x1800
#define AzGl_COLORBURN_KHR 0x929A
#define AzGl_COLORDODGE_KHR 0x9299
#define AzGl_COLOR_ARRAY 0x8076
#define AzGl_COLOR_ARRAY_BUFFER_BINDING 0x8898
#define AzGl_COLOR_ARRAY_POINTER 0x8090
#define AzGl_COLOR_ARRAY_SIZE 0x8081
#define AzGl_COLOR_ARRAY_STRIDE 0x8083
#define AzGl_COLOR_ARRAY_TYPE 0x8082
#define AzGl_COLOR_ATTACHMENT0 0x8CE0
#define AzGl_COLOR_ATTACHMENT1 0x8CE1
#define AzGl_COLOR_ATTACHMENT10 0x8CEA
#define AzGl_COLOR_ATTACHMENT11 0x8CEB
#define AzGl_COLOR_ATTACHMENT12 0x8CEC
#define AzGl_COLOR_ATTACHMENT13 0x8CED
#define AzGl_COLOR_ATTACHMENT14 0x8CEE
#define AzGl_COLOR_ATTACHMENT15 0x8CEF
#define AzGl_COLOR_ATTACHMENT16 0x8CF0
#define AzGl_COLOR_ATTACHMENT17 0x8CF1
#define AzGl_COLOR_ATTACHMENT18 0x8CF2
#define AzGl_COLOR_ATTACHMENT19 0x8CF3
#define AzGl_COLOR_ATTACHMENT2 0x8CE2
#define AzGl_COLOR_ATTACHMENT20 0x8CF4
#define AzGl_COLOR_ATTACHMENT21 0x8CF5
#define AzGl_COLOR_ATTACHMENT22 0x8CF6
#define AzGl_COLOR_ATTACHMENT23 0x8CF7
#define AzGl_COLOR_ATTACHMENT24 0x8CF8
#define AzGl_COLOR_ATTACHMENT25 0x8CF9
#define AzGl_COLOR_ATTACHMENT26 0x8CFA
#define AzGl_COLOR_ATTACHMENT27 0x8CFB
#define AzGl_COLOR_ATTACHMENT28 0x8CFC
#define AzGl_COLOR_ATTACHMENT29 0x8CFD
#define AzGl_COLOR_ATTACHMENT3 0x8CE3
#define AzGl_COLOR_ATTACHMENT30 0x8CFE
#define AzGl_COLOR_ATTACHMENT31 0x8CFF
#define AzGl_COLOR_ATTACHMENT4 0x8CE4
#define AzGl_COLOR_ATTACHMENT5 0x8CE5
#define AzGl_COLOR_ATTACHMENT6 0x8CE6
#define AzGl_COLOR_ATTACHMENT7 0x8CE7
#define AzGl_COLOR_ATTACHMENT8 0x8CE8
#define AzGl_COLOR_ATTACHMENT9 0x8CE9
#define AzGl_COLOR_BUFFER_BIT 0x00004000
#define AzGl_COLOR_CLEAR_VALUE 0x0C22
#define AzGl_COLOR_INDEX 0x1900
#define AzGl_COLOR_INDEXES 0x1603
#define AzGl_COLOR_LOGIC_OP 0x0BF2
#define AzGl_COLOR_MATERIAL 0x0B57
#define AzGl_COLOR_MATERIAL_FACE 0x0B55
#define AzGl_COLOR_MATERIAL_PARAMETER 0x0B56
#define AzGl_COLOR_SUM 0x8458
#define AzGl_COLOR_WRITEMASK 0x0C23
#define AzGl_COMBINE 0x8570
#define AzGl_COMBINE_ALPHA 0x8572
#define AzGl_COMBINE_RGB 0x8571
#define AzGl_COMPARE_REF_TO_TEXTURE 0x884E
#define AzGl_COMPARE_R_TO_TEXTURE 0x884E
#define AzGl_COMPILE 0x1300
#define AzGl_COMPILE_AND_EXECUTE 0x1301
#define AzGl_COMPILE_STATUS 0x8B81
#define AzGl_COMPRESSED_ALPHA 0x84E9
#define AzGl_COMPRESSED_INTENSITY 0x84EC
#define AzGl_COMPRESSED_LUMINANCE 0x84EA
#define AzGl_COMPRESSED_LUMINANCE_ALPHA 0x84EB
#define AzGl_COMPRESSED_R11_EAC 0x9270
#define AzGl_COMPRESSED_RED 0x8225
#define AzGl_COMPRESSED_RED_RGTC1 0x8DBB
#define AzGl_COMPRESSED_RG 0x8226
#define AzGl_COMPRESSED_RG11_EAC 0x9272
#define AzGl_COMPRESSED_RGB 0x84ED
#define AzGl_COMPRESSED_RGB8_ETC2 0x9274
#define AzGl_COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2 0x9276
#define AzGl_COMPRESSED_RGBA 0x84EE
#define AzGl_COMPRESSED_RGBA8_ETC2_EAC 0x9278
#define AzGl_COMPRESSED_RG_RGTC2 0x8DBD
#define AzGl_COMPRESSED_SIGNED_R11_EAC 0x9271
#define AzGl_COMPRESSED_SIGNED_RED_RGTC1 0x8DBC
#define AzGl_COMPRESSED_SIGNED_RG11_EAC 0x9273
#define AzGl_COMPRESSED_SIGNED_RG_RGTC2 0x8DBE
#define AzGl_COMPRESSED_SLUMINANCE 0x8C4A
#define AzGl_COMPRESSED_SLUMINANCE_ALPHA 0x8C4B
#define AzGl_COMPRESSED_SRGB 0x8C48
#define AzGl_COMPRESSED_SRGB8_ALPHA8_ETC2_EAC 0x9279
#define AzGl_COMPRESSED_SRGB8_ETC2 0x9275
#define AzGl_COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2 0x9277
#define AzGl_COMPRESSED_SRGB_ALPHA 0x8C49
#define AzGl_COMPRESSED_TEXTURE_FORMATS 0x86A3
#define AzGl_CONDITION_SATISFIED 0x911C
#define AzGl_CONSTANT 0x8576
#define AzGl_CONSTANT_ALPHA 0x8003
#define AzGl_CONSTANT_ATTENUATION 0x1207
#define AzGl_CONSTANT_COLOR 0x8001
#define AzGl_CONTEXT_COMPATIBILITY_PROFILE_BIT 0x00000002
#define AzGl_CONTEXT_CORE_PROFILE_BIT 0x00000001
#define AzGl_CONTEXT_FLAGS 0x821E
#define AzGl_CONTEXT_FLAG_DEBUG_BIT 0x00000002
#define AzGl_CONTEXT_FLAG_DEBUG_BIT_KHR 0x00000002
#define AzGl_CONTEXT_FLAG_FORWARD_COMPATIBLE_BIT 0x00000001
#define AzGl_CONTEXT_PROFILE_MASK 0x9126
#define AzGl_COORD_REPLACE 0x8862
#define AzGl_COPY 0x1503
#define AzGl_COPY_INVERTED 0x150C
#define AzGl_COPY_PIXEL_TOKEN 0x0706
#define AzGl_COPY_READ_BUFFER 0x8F36
#define AzGl_COPY_READ_BUFFER_BINDING 0x8F36
#define AzGl_COPY_WRITE_BUFFER 0x8F37
#define AzGl_COPY_WRITE_BUFFER_BINDING 0x8F37
#define AzGl_CULL_FACE 0x0B44
#define AzGl_CULL_FACE_MODE 0x0B45
#define AzGl_CURRENT_BIT 0x00000001
#define AzGl_CURRENT_COLOR 0x0B00
#define AzGl_CURRENT_FOG_COORD 0x8453
#define AzGl_CURRENT_FOG_COORDINATE 0x8453
#define AzGl_CURRENT_INDEX 0x0B01
#define AzGl_CURRENT_NORMAL 0x0B02
#define AzGl_CURRENT_PROGRAM 0x8B8D
#define AzGl_CURRENT_QUERY 0x8865
#define AzGl_CURRENT_QUERY_EXT 0x8865
#define AzGl_CURRENT_RASTER_COLOR 0x0B04
#define AzGl_CURRENT_RASTER_DISTANCE 0x0B09
#define AzGl_CURRENT_RASTER_INDEX 0x0B05
#define AzGl_CURRENT_RASTER_POSITION 0x0B07
#define AzGl_CURRENT_RASTER_POSITION_VALID 0x0B08
#define AzGl_CURRENT_RASTER_SECONDARY_COLOR 0x845F
#define AzGl_CURRENT_RASTER_TEXTURE_COORDS 0x0B06
#define AzGl_CURRENT_SECONDARY_COLOR 0x8459
#define AzGl_CURRENT_TEXTURE_COORDS 0x0B03
#define AzGl_CURRENT_VERTEX_ATTRIB 0x8626
#define AzGl_CW 0x0900
#define AzGl_DARKEN_KHR 0x9297
#define AzGl_DEBUG_CALLBACK_FUNCTION 0x8244
#define AzGl_DEBUG_CALLBACK_FUNCTION_KHR 0x8244
#define AzGl_DEBUG_CALLBACK_USER_PARAM 0x8245
#define AzGl_DEBUG_CALLBACK_USER_PARAM_KHR 0x8245
#define AzGl_DEBUG_GROUP_STACK_DEPTH 0x826D
#define AzGl_DEBUG_GROUP_STACK_DEPTH_KHR 0x826D
#define AzGl_DEBUG_LOGGED_MESSAGES 0x9145
#define AzGl_DEBUG_LOGGED_MESSAGES_KHR 0x9145
#define AzGl_DEBUG_NEXT_LOGGED_MESSAGE_LENGTH 0x8243
#define AzGl_DEBUG_NEXT_LOGGED_MESSAGE_LENGTH_KHR 0x8243
#define AzGl_DEBUG_OUTPUT 0x92E0
#define AzGl_DEBUG_OUTPUT_KHR 0x92E0
#define AzGl_DEBUG_OUTPUT_SYNCHRONOUS 0x8242
#define AzGl_DEBUG_OUTPUT_SYNCHRONOUS_KHR 0x8242
#define AzGl_DEBUG_SEVERITY_HIGH 0x9146
#define AzGl_DEBUG_SEVERITY_HIGH_KHR 0x9146
#define AzGl_DEBUG_SEVERITY_LOW 0x9148
#define AzGl_DEBUG_SEVERITY_LOW_KHR 0x9148
#define AzGl_DEBUG_SEVERITY_MEDIUM 0x9147
#define AzGl_DEBUG_SEVERITY_MEDIUM_KHR 0x9147
#define AzGl_DEBUG_SEVERITY_NOTIFICATION 0x826B
#define AzGl_DEBUG_SEVERITY_NOTIFICATION_KHR 0x826B
#define AzGl_DEBUG_SOURCE_API 0x8246
#define AzGl_DEBUG_SOURCE_API_KHR 0x8246
#define AzGl_DEBUG_SOURCE_APPLICATION 0x824A
#define AzGl_DEBUG_SOURCE_APPLICATION_KHR 0x824A
#define AzGl_DEBUG_SOURCE_OTHER 0x824B
#define AzGl_DEBUG_SOURCE_OTHER_KHR 0x824B
#define AzGl_DEBUG_SOURCE_SHADER_COMPILER 0x8248
#define AzGl_DEBUG_SOURCE_SHADER_COMPILER_KHR 0x8248
#define AzGl_DEBUG_SOURCE_THIRD_PARTY 0x8249
#define AzGl_DEBUG_SOURCE_THIRD_PARTY_KHR 0x8249
#define AzGl_DEBUG_SOURCE_WINDOW_SYSTEM 0x8247
#define AzGl_DEBUG_SOURCE_WINDOW_SYSTEM_KHR 0x8247
#define AzGl_DEBUG_TYPE_DEPRECATED_BEHAVIOR 0x824D
#define AzGl_DEBUG_TYPE_DEPRECATED_BEHAVIOR_KHR 0x824D
#define AzGl_DEBUG_TYPE_ERROR 0x824C
#define AzGl_DEBUG_TYPE_ERROR_KHR 0x824C
#define AzGl_DEBUG_TYPE_MARKER 0x8268
#define AzGl_DEBUG_TYPE_MARKER_KHR 0x8268
#define AzGl_DEBUG_TYPE_OTHER 0x8251
#define AzGl_DEBUG_TYPE_OTHER_KHR 0x8251
#define AzGl_DEBUG_TYPE_PERFORMANCE 0x8250
#define AzGl_DEBUG_TYPE_PERFORMANCE_KHR 0x8250
#define AzGl_DEBUG_TYPE_POP_GROUP 0x826A
#define AzGl_DEBUG_TYPE_POP_GROUP_KHR 0x826A
#define AzGl_DEBUG_TYPE_PORTABILITY 0x824F
#define AzGl_DEBUG_TYPE_PORTABILITY_KHR 0x824F
#define AzGl_DEBUG_TYPE_PUSH_GROUP 0x8269
#define AzGl_DEBUG_TYPE_PUSH_GROUP_KHR 0x8269
#define AzGl_DEBUG_TYPE_UNDEFINED_BEHAVIOR 0x824E
#define AzGl_DEBUG_TYPE_UNDEFINED_BEHAVIOR_KHR 0x824E
#define AzGl_DECAL 0x2101
#define AzGl_DECR 0x1E03
#define AzGl_DECR_WRAP 0x8508
#define AzGl_DELETE_STATUS 0x8B80
#define AzGl_DEPTH 0x1801
#define AzGl_DEPTH24_STENCIL8 0x88F0
#define AzGl_DEPTH32F_STENCIL8 0x8CAD
#define AzGl_DEPTH_ATTACHMENT 0x8D00
#define AzGl_DEPTH_BIAS 0x0D1F
#define AzGl_DEPTH_BITS 0x0D56
#define AzGl_DEPTH_BUFFER_BIT 0x00000100
#define AzGl_DEPTH_CLAMP 0x864F
#define AzGl_DEPTH_CLEAR_VALUE 0x0B73
#define AzGl_DEPTH_COMPONENT 0x1902
#define AzGl_DEPTH_COMPONENT16 0x81A5
#define AzGl_DEPTH_COMPONENT24 0x81A6
#define AzGl_DEPTH_COMPONENT32 0x81A7
#define AzGl_DEPTH_COMPONENT32F 0x8CAC
#define AzGl_DEPTH_FUNC 0x0B74
#define AzGl_DEPTH_RANGE 0x0B70
#define AzGl_DEPTH_SCALE 0x0D1E
#define AzGl_DEPTH_STENCIL 0x84F9
#define AzGl_DEPTH_STENCIL_ATTACHMENT 0x821A
#define AzGl_DEPTH_TEST 0x0B71
#define AzGl_DEPTH_TEXTURE_MODE 0x884B
#define AzGl_DEPTH_WRITEMASK 0x0B72
#define AzGl_DIFFERENCE_KHR 0x929E
#define AzGl_DIFFUSE 0x1201
#define AzGl_DISPLAY_LIST 0x82E7
#define AzGl_DITHER 0x0BD0
#define AzGl_DOMAIN 0x0A02
#define AzGl_DONT_CARE 0x1100
#define AzGl_DOT3_RGB 0x86AE
#define AzGl_DOT3_RGBA 0x86AF
#define AzGl_DOUBLE 0x140A
#define AzGl_DOUBLEBUFFER 0x0C32
#define AzGl_DRAW_BUFFER 0x0C01
#define AzGl_DRAW_BUFFER0 0x8825
#define AzGl_DRAW_BUFFER1 0x8826
#define AzGl_DRAW_BUFFER10 0x882F
#define AzGl_DRAW_BUFFER11 0x8830
#define AzGl_DRAW_BUFFER12 0x8831
#define AzGl_DRAW_BUFFER13 0x8832
#define AzGl_DRAW_BUFFER14 0x8833
#define AzGl_DRAW_BUFFER15 0x8834
#define AzGl_DRAW_BUFFER2 0x8827
#define AzGl_DRAW_BUFFER3 0x8828
#define AzGl_DRAW_BUFFER4 0x8829
#define AzGl_DRAW_BUFFER5 0x882A
#define AzGl_DRAW_BUFFER6 0x882B
#define AzGl_DRAW_BUFFER7 0x882C
#define AzGl_DRAW_BUFFER8 0x882D
#define AzGl_DRAW_BUFFER9 0x882E
#define AzGl_DRAW_FRAMEBUFFER 0x8CA9
#define AzGl_DRAW_FRAMEBUFFER_BINDING 0x8CA6
#define AzGl_DRAW_PIXELS_APPLE 0x8A0A
#define AzGl_DRAW_PIXEL_TOKEN 0x0705
#define AzGl_DST_ALPHA 0x0304
#define AzGl_DST_COLOR 0x0306
#define AzGl_DYNAMIC_COPY 0x88EA
#define AzGl_DYNAMIC_DRAW 0x88E8
#define AzGl_DYNAMIC_READ 0x88E9
#define AzGl_EDGE_FLAG 0x0B43
#define AzGl_EDGE_FLAG_ARRAY 0x8079
#define AzGl_EDGE_FLAG_ARRAY_BUFFER_BINDING 0x889B
#define AzGl_EDGE_FLAG_ARRAY_POINTER 0x8093
#define AzGl_EDGE_FLAG_ARRAY_STRIDE 0x808C
#define AzGl_ELEMENT_ARRAY_BUFFER 0x8893
#define AzGl_ELEMENT_ARRAY_BUFFER_BINDING 0x8895
#define AzGl_EMISSION 0x1600
#define AzGl_ENABLE_BIT 0x00002000
#define AzGl_EQUAL 0x0202
#define AzGl_EQUIV 0x1509
#define AzGl_EVAL_BIT 0x00010000
#define AzGl_EXCLUSION_KHR 0x92A0
#define AzGl_EXP 0x0800
#define AzGl_EXP2 0x0801
#define AzGl_EXTENSIONS 0x1F03
#define AzGl_EYE_LINEAR 0x2400
#define AzGl_EYE_PLANE 0x2502
#define AzGl_FALSE 0
#define AzGl_FASTEST 0x1101
#define AzGl_FEEDBACK 0x1C01
#define AzGl_FEEDBACK_BUFFER_POINTER 0x0DF0
#define AzGl_FEEDBACK_BUFFER_SIZE 0x0DF1
#define AzGl_FEEDBACK_BUFFER_TYPE 0x0DF2
#define AzGl_FENCE_APPLE 0x8A0B
#define AzGl_FILL 0x1B02
#define AzGl_FIRST_VERTEX_CONVENTION 0x8E4D
#define AzGl_FIXED 0x140C
#define AzGl_FIXED_ONLY 0x891D
#define AzGl_FLAT 0x1D00
#define AzGl_FLOAT 0x1406
#define AzGl_FLOAT_32_UNSIGNED_INT_24_8_REV 0x8DAD
#define AzGl_FLOAT_MAT2 0x8B5A
#define AzGl_FLOAT_MAT2x3 0x8B65
#define AzGl_FLOAT_MAT2x4 0x8B66
#define AzGl_FLOAT_MAT3 0x8B5B
#define AzGl_FLOAT_MAT3x2 0x8B67
#define AzGl_FLOAT_MAT3x4 0x8B68
#define AzGl_FLOAT_MAT4 0x8B5C
#define AzGl_FLOAT_MAT4x2 0x8B69
#define AzGl_FLOAT_MAT4x3 0x8B6A
#define AzGl_FLOAT_VEC2 0x8B50
#define AzGl_FLOAT_VEC3 0x8B51
#define AzGl_FLOAT_VEC4 0x8B52
#define AzGl_FOG 0x0B60
#define AzGl_FOG_BIT 0x00000080
#define AzGl_FOG_COLOR 0x0B66
#define AzGl_FOG_COORD 0x8451
#define AzGl_FOG_COORDINATE 0x8451
#define AzGl_FOG_COORDINATE_ARRAY 0x8457
#define AzGl_FOG_COORDINATE_ARRAY_BUFFER_BINDING 0x889D
#define AzGl_FOG_COORDINATE_ARRAY_POINTER 0x8456
#define AzGl_FOG_COORDINATE_ARRAY_STRIDE 0x8455
#define AzGl_FOG_COORDINATE_ARRAY_TYPE 0x8454
#define AzGl_FOG_COORDINATE_SOURCE 0x8450
#define AzGl_FOG_COORD_ARRAY 0x8457
#define AzGl_FOG_COORD_ARRAY_BUFFER_BINDING 0x889D
#define AzGl_FOG_COORD_ARRAY_POINTER 0x8456
#define AzGl_FOG_COORD_ARRAY_STRIDE 0x8455
#define AzGl_FOG_COORD_ARRAY_TYPE 0x8454
#define AzGl_FOG_COORD_SRC 0x8450
#define AzGl_FOG_DENSITY 0x0B62
#define AzGl_FOG_END 0x0B64
#define AzGl_FOG_HINT 0x0C54
#define AzGl_FOG_INDEX 0x0B61
#define AzGl_FOG_MODE 0x0B65
#define AzGl_FOG_START 0x0B63
#define AzGl_FRAGMENT_DEPTH 0x8452
#define AzGl_FRAGMENT_SHADER 0x8B30
#define AzGl_FRAGMENT_SHADER_DERIVATIVE_HINT 0x8B8B
#define AzGl_FRAMEBUFFER 0x8D40
#define AzGl_FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE 0x8215
#define AzGl_FRAMEBUFFER_ATTACHMENT_ANGLE 0x93A3
#define AzGl_FRAMEBUFFER_ATTACHMENT_BLUE_SIZE 0x8214
#define AzGl_FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING 0x8210
#define AzGl_FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE 0x8211
#define AzGl_FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE 0x8216
#define AzGl_FRAMEBUFFER_ATTACHMENT_GREEN_SIZE 0x8213
#define AzGl_FRAMEBUFFER_ATTACHMENT_LAYERED 0x8DA7
#define AzGl_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME 0x8CD1
#define AzGl_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE 0x8CD0
#define AzGl_FRAMEBUFFER_ATTACHMENT_RED_SIZE 0x8212
#define AzGl_FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE 0x8217
#define AzGl_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE 0x8CD3
#define AzGl_FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER 0x8CD4
#define AzGl_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL 0x8CD2
#define AzGl_FRAMEBUFFER_BINDING 0x8CA6
#define AzGl_FRAMEBUFFER_COMPLETE 0x8CD5
#define AzGl_FRAMEBUFFER_DEFAULT 0x8218
#define AzGl_FRAMEBUFFER_INCOMPLETE_ATTACHMENT 0x8CD6
#define AzGl_FRAMEBUFFER_INCOMPLETE_DIMENSIONS 0x8CD9
#define AzGl_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER 0x8CDB
#define AzGl_FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS 0x8DA8
#define AzGl_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT 0x8CD7
#define AzGl_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE 0x8D56
#define AzGl_FRAMEBUFFER_INCOMPLETE_READ_BUFFER 0x8CDC
#define AzGl_FRAMEBUFFER_SRGB 0x8DB9
#define AzGl_FRAMEBUFFER_UNDEFINED 0x8219
#define AzGl_FRAMEBUFFER_UNSUPPORTED 0x8CDD
#define AzGl_FRONT 0x0404
#define AzGl_FRONT_AND_BACK 0x0408
#define AzGl_FRONT_FACE 0x0B46
#define AzGl_FRONT_LEFT 0x0400
#define AzGl_FRONT_RIGHT 0x0401
#define AzGl_FUNC_ADD 0x8006
#define AzGl_FUNC_REVERSE_SUBTRACT 0x800B
#define AzGl_FUNC_SUBTRACT 0x800A
#define AzGl_GENERATE_MIPMAP 0x8191
#define AzGl_GENERATE_MIPMAP_HINT 0x8192
#define AzGl_GEOMETRY_INPUT_TYPE 0x8917
#define AzGl_GEOMETRY_OUTPUT_TYPE 0x8918
#define AzGl_GEOMETRY_SHADER 0x8DD9
#define AzGl_GEOMETRY_VERTICES_OUT 0x8916
#define AzGl_GEQUAL 0x0206
#define AzGl_GPU_DISJOINT_EXT 0x8FBB
#define AzGl_GREATER 0x0204
#define AzGl_GREEN 0x1904
#define AzGl_GREEN_BIAS 0x0D19
#define AzGl_GREEN_BITS 0x0D53
#define AzGl_GREEN_INTEGER 0x8D95
#define AzGl_GREEN_SCALE 0x0D18
#define AzGl_HALF_FLOAT 0x140B
#define AzGl_HALF_FLOAT_OES 0x8D61
#define AzGl_HARDLIGHT_KHR 0x929B
#define AzGl_HIGH_FLOAT 0x8DF2
#define AzGl_HIGH_INT 0x8DF5
#define AzGl_HINT_BIT 0x00008000
#define AzGl_HSL_COLOR_KHR 0x92AF
#define AzGl_HSL_HUE_KHR 0x92AD
#define AzGl_HSL_LUMINOSITY_KHR 0x92B0
#define AzGl_HSL_SATURATION_KHR 0x92AE
#define AzGl_IMPLEMENTATION_COLOR_READ_FORMAT 0x8B9B
#define AzGl_IMPLEMENTATION_COLOR_READ_TYPE 0x8B9A
#define AzGl_INCR 0x1E02
#define AzGl_INCR_WRAP 0x8507
#define AzGl_INDEX 0x8222
#define AzGl_INDEX_ARRAY 0x8077
#define AzGl_INDEX_ARRAY_BUFFER_BINDING 0x8899
#define AzGl_INDEX_ARRAY_POINTER 0x8091
#define AzGl_INDEX_ARRAY_STRIDE 0x8086
#define AzGl_INDEX_ARRAY_TYPE 0x8085
#define AzGl_INDEX_BITS 0x0D51
#define AzGl_INDEX_CLEAR_VALUE 0x0C20
#define AzGl_INDEX_LOGIC_OP 0x0BF1
#define AzGl_INDEX_MODE 0x0C30
#define AzGl_INDEX_OFFSET 0x0D13
#define AzGl_INDEX_SHIFT 0x0D12
#define AzGl_INDEX_WRITEMASK 0x0C21
#define AzGl_INFO_LOG_LENGTH 0x8B84
#define AzGl_INT 0x1404
#define AzGl_INTENSITY 0x8049
#define AzGl_INTENSITY12 0x804C
#define AzGl_INTENSITY16 0x804D
#define AzGl_INTENSITY4 0x804A
#define AzGl_INTENSITY8 0x804B
#define AzGl_INTERLEAVED_ATTRIBS 0x8C8C
#define AzGl_INTERPOLATE 0x8575
#define AzGl_INT_2_10_10_10_REV 0x8D9F
#define AzGl_INT_SAMPLER_1D 0x8DC9
#define AzGl_INT_SAMPLER_1D_ARRAY 0x8DCE
#define AzGl_INT_SAMPLER_2D 0x8DCA
#define AzGl_INT_SAMPLER_2D_ARRAY 0x8DCF
#define AzGl_INT_SAMPLER_2D_MULTISAMPLE 0x9109
#define AzGl_INT_SAMPLER_2D_MULTISAMPLE_ARRAY 0x910C
#define AzGl_INT_SAMPLER_2D_RECT 0x8DCD
#define AzGl_INT_SAMPLER_3D 0x8DCB
#define AzGl_INT_SAMPLER_BUFFER 0x8DD0
#define AzGl_INT_SAMPLER_CUBE 0x8DCC
#define AzGl_INT_VEC2 0x8B53
#define AzGl_INT_VEC3 0x8B54
#define AzGl_INT_VEC4 0x8B55
#define AzGl_INVALID_ENUM 0x0500
#define AzGl_INVALID_FRAMEBUFFER_OPERATION 0x0506
#define AzGl_INVALID_INDEX 0xFFFFFFFF
#define AzGl_INVALID_OPERATION 0x0502
#define AzGl_INVALID_VALUE 0x0501
#define AzGl_INVERT 0x150A
#define AzGl_KEEP 0x1E00
#define AzGl_LAST_VERTEX_CONVENTION 0x8E4E
#define AzGl_LEFT 0x0406
#define AzGl_LEQUAL 0x0203
#define AzGl_LESS 0x0201
#define AzGl_LIGHT0 0x4000
#define AzGl_LIGHT1 0x4001
#define AzGl_LIGHT2 0x4002
#define AzGl_LIGHT3 0x4003
#define AzGl_LIGHT4 0x4004
#define AzGl_LIGHT5 0x4005
#define AzGl_LIGHT6 0x4006
#define AzGl_LIGHT7 0x4007
#define AzGl_LIGHTEN_KHR 0x9298
#define AzGl_LIGHTING 0x0B50
#define AzGl_LIGHTING_BIT 0x00000040
#define AzGl_LIGHT_MODEL_AMBIENT 0x0B53
#define AzGl_LIGHT_MODEL_COLOR_CONTROL 0x81F8
#define AzGl_LIGHT_MODEL_LOCAL_VIEWER 0x0B51
#define AzGl_LIGHT_MODEL_TWO_SIDE 0x0B52
#define AzGl_LINE 0x1B01
#define AzGl_LINEAR 0x2601
#define AzGl_LINEAR_ATTENUATION 0x1208
#define AzGl_LINEAR_MIPMAP_LINEAR 0x2703
#define AzGl_LINEAR_MIPMAP_NEAREST 0x2701
#define AzGl_LINES 0x0001
#define AzGl_LINES_ADJACENCY 0x000A
#define AzGl_LINE_BIT 0x00000004
#define AzGl_LINE_LOOP 0x0002
#define AzGl_LINE_RESET_TOKEN 0x0707
#define AzGl_LINE_SMOOTH 0x0B20
#define AzGl_LINE_SMOOTH_HINT 0x0C52
#define AzGl_LINE_STIPPLE 0x0B24
#define AzGl_LINE_STIPPLE_PATTERN 0x0B25
#define AzGl_LINE_STIPPLE_REPEAT 0x0B26
#define AzGl_LINE_STRIP 0x0003
#define AzGl_LINE_STRIP_ADJACENCY 0x000B
#define AzGl_LINE_TOKEN 0x0702
#define AzGl_LINE_WIDTH 0x0B21
#define AzGl_LINE_WIDTH_GRANULARITY 0x0B23
#define AzGl_LINE_WIDTH_RANGE 0x0B22
#define AzGl_LINK_STATUS 0x8B82
#define AzGl_LIST_BASE 0x0B32
#define AzGl_LIST_BIT 0x00020000
#define AzGl_LIST_INDEX 0x0B33
#define AzGl_LIST_MODE 0x0B30
#define AzGl_LOAD 0x0101
#define AzGl_LOGIC_OP 0x0BF1
#define AzGl_LOGIC_OP_MODE 0x0BF0
#define AzGl_LOWER_LEFT 0x8CA1
#define AzGl_LOW_FLOAT 0x8DF0
#define AzGl_LOW_INT 0x8DF3
#define AzGl_LUMINANCE 0x1909
#define AzGl_LUMINANCE12 0x8041
#define AzGl_LUMINANCE12_ALPHA12 0x8047
#define AzGl_LUMINANCE12_ALPHA4 0x8046
#define AzGl_LUMINANCE16 0x8042
#define AzGl_LUMINANCE16F_EXT 0x881E
#define AzGl_LUMINANCE16_ALPHA16 0x8048
#define AzGl_LUMINANCE32F_EXT 0x8818
#define AzGl_LUMINANCE4 0x803F
#define AzGl_LUMINANCE4_ALPHA4 0x8043
#define AzGl_LUMINANCE6_ALPHA2 0x8044
#define AzGl_LUMINANCE8 0x8040
#define AzGl_LUMINANCE8_ALPHA8 0x8045
#define AzGl_LUMINANCE8_ALPHA8_EXT 0x8045
#define AzGl_LUMINANCE8_EXT 0x8040
#define AzGl_LUMINANCE_ALPHA 0x190A
#define AzGl_LUMINANCE_ALPHA16F_EXT 0x881F
#define AzGl_LUMINANCE_ALPHA32F_EXT 0x8819
#define AzGl_MAJOR_VERSION 0x821B
#define AzGl_MAP1_COLOR_4 0x0D90
#define AzGl_MAP1_GRID_DOMAIN 0x0DD0
#define AzGl_MAP1_GRID_SEGMENTS 0x0DD1
#define AzGl_MAP1_INDEX 0x0D91
#define AzGl_MAP1_NORMAL 0x0D92
#define AzGl_MAP1_TEXTURE_COORD_1 0x0D93
#define AzGl_MAP1_TEXTURE_COORD_2 0x0D94
#define AzGl_MAP1_TEXTURE_COORD_3 0x0D95
#define AzGl_MAP1_TEXTURE_COORD_4 0x0D96
#define AzGl_MAP1_VERTEX_3 0x0D97
#define AzGl_MAP1_VERTEX_4 0x0D98
#define AzGl_MAP2_COLOR_4 0x0DB0
#define AzGl_MAP2_GRID_DOMAIN 0x0DD2
#define AzGl_MAP2_GRID_SEGMENTS 0x0DD3
#define AzGl_MAP2_INDEX 0x0DB1
#define AzGl_MAP2_NORMAL 0x0DB2
#define AzGl_MAP2_TEXTURE_COORD_1 0x0DB3
#define AzGl_MAP2_TEXTURE_COORD_2 0x0DB4
#define AzGl_MAP2_TEXTURE_COORD_3 0x0DB5
#define AzGl_MAP2_TEXTURE_COORD_4 0x0DB6
#define AzGl_MAP2_VERTEX_3 0x0DB7
#define AzGl_MAP2_VERTEX_4 0x0DB8
#define AzGl_MAP_COLOR 0x0D10
#define AzGl_MAP_FLUSH_EXPLICIT_BIT 0x0010
#define AzGl_MAP_INVALIDATE_BUFFER_BIT 0x0008
#define AzGl_MAP_INVALIDATE_RANGE_BIT 0x0004
#define AzGl_MAP_READ_BIT 0x0001
#define AzGl_MAP_STENCIL 0x0D11
#define AzGl_MAP_UNSYNCHRONIZED_BIT 0x0020
#define AzGl_MAP_WRITE_BIT 0x0002
#define AzGl_MATRIX_MODE 0x0BA0
#define AzGl_MAX 0x8008
#define AzGl_MAX_3D_TEXTURE_SIZE 0x8073
#define AzGl_MAX_ARRAY_TEXTURE_LAYERS 0x88FF
#define AzGl_MAX_ATTRIB_STACK_DEPTH 0x0D35
#define AzGl_MAX_CLIENT_ATTRIB_STACK_DEPTH 0x0D3B
#define AzGl_MAX_CLIP_DISTANCES 0x0D32
#define AzGl_MAX_CLIP_PLANES 0x0D32
#define AzGl_MAX_COLOR_ATTACHMENTS 0x8CDF
#define AzGl_MAX_COLOR_TEXTURE_SAMPLES 0x910E
#define AzGl_MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS 0x8A33
#define AzGl_MAX_COMBINED_GEOMETRY_UNIFORM_COMPONENTS 0x8A32
#define AzGl_MAX_COMBINED_TEXTURE_IMAGE_UNITS 0x8B4D
#define AzGl_MAX_COMBINED_UNIFORM_BLOCKS 0x8A2E
#define AzGl_MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS 0x8A31
#define AzGl_MAX_CUBE_MAP_TEXTURE_SIZE 0x851C
#define AzGl_MAX_DEBUG_GROUP_STACK_DEPTH 0x826C
#define AzGl_MAX_DEBUG_GROUP_STACK_DEPTH_KHR 0x826C
#define AzGl_MAX_DEBUG_LOGGED_MESSAGES 0x9144
#define AzGl_MAX_DEBUG_LOGGED_MESSAGES_KHR 0x9144
#define AzGl_MAX_DEBUG_MESSAGE_LENGTH 0x9143
#define AzGl_MAX_DEBUG_MESSAGE_LENGTH_KHR 0x9143
#define AzGl_MAX_DEPTH_TEXTURE_SAMPLES 0x910F
#define AzGl_MAX_DRAW_BUFFERS 0x8824
#define AzGl_MAX_DUAL_SOURCE_DRAW_BUFFERS 0x88FC
#define AzGl_MAX_ELEMENTS_INDICES 0x80E9
#define AzGl_MAX_ELEMENTS_VERTICES 0x80E8
#define AzGl_MAX_ELEMENT_INDEX 0x8D6B
#define AzGl_MAX_EVAL_ORDER 0x0D30
#define AzGl_MAX_FRAGMENT_INPUT_COMPONENTS 0x9125
#define AzGl_MAX_FRAGMENT_UNIFORM_BLOCKS 0x8A2D
#define AzGl_MAX_FRAGMENT_UNIFORM_COMPONENTS 0x8B49
#define AzGl_MAX_FRAGMENT_UNIFORM_VECTORS 0x8DFD
#define AzGl_MAX_GEOMETRY_INPUT_COMPONENTS 0x9123
#define AzGl_MAX_GEOMETRY_OUTPUT_COMPONENTS 0x9124
#define AzGl_MAX_GEOMETRY_OUTPUT_VERTICES 0x8DE0
#define AzGl_MAX_GEOMETRY_TEXTURE_IMAGE_UNITS 0x8C29
#define AzGl_MAX_GEOMETRY_TOTAL_OUTPUT_COMPONENTS 0x8DE1
#define AzGl_MAX_GEOMETRY_UNIFORM_BLOCKS 0x8A2C
#define AzGl_MAX_GEOMETRY_UNIFORM_COMPONENTS 0x8DDF
#define AzGl_MAX_INTEGER_SAMPLES 0x9110
#define AzGl_MAX_LABEL_LENGTH 0x82E8
#define AzGl_MAX_LABEL_LENGTH_KHR 0x82E8
#define AzGl_MAX_LIGHTS 0x0D31
#define AzGl_MAX_LIST_NESTING 0x0B31
#define AzGl_MAX_MODELVIEW_STACK_DEPTH 0x0D36
#define AzGl_MAX_NAME_STACK_DEPTH 0x0D37
#define AzGl_MAX_PIXEL_MAP_TABLE 0x0D34
#define AzGl_MAX_PROGRAM_TEXEL_OFFSET 0x8905
#define AzGl_MAX_PROJECTION_STACK_DEPTH 0x0D38
#define AzGl_MAX_RECTANGLE_TEXTURE_SIZE 0x84F8
#define AzGl_MAX_RECTANGLE_TEXTURE_SIZE_ARB 0x84F8
#define AzGl_MAX_RENDERBUFFER_SIZE 0x84E8
#define AzGl_MAX_SAMPLES 0x8D57
#define AzGl_MAX_SAMPLE_MASK_WORDS 0x8E59
#define AzGl_MAX_SERVER_WAIT_TIMEOUT 0x9111
#define AzGl_MAX_SHADER_PIXEL_LOCAL_STORAGE_FAST_SIZE_EXT 0x8F63
#define AzGl_MAX_SHADER_PIXEL_LOCAL_STORAGE_SIZE_EXT 0x8F67
#define AzGl_MAX_TEXTURE_BUFFER_SIZE 0x8C2B
#define AzGl_MAX_TEXTURE_COORDS 0x8871
#define AzGl_MAX_TEXTURE_IMAGE_UNITS 0x8872
#define AzGl_MAX_TEXTURE_LOD_BIAS 0x84FD
#define AzGl_MAX_TEXTURE_MAX_ANISOTROPY_EXT 0x84FF
#define AzGl_MAX_TEXTURE_SIZE 0x0D33
#define AzGl_MAX_TEXTURE_STACK_DEPTH 0x0D39
#define AzGl_MAX_TEXTURE_UNITS 0x84E2
#define AzGl_MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS 0x8C8A
#define AzGl_MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS 0x8C8B
#define AzGl_MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS 0x8C80
#define AzGl_MAX_UNIFORM_BLOCK_SIZE 0x8A30
#define AzGl_MAX_UNIFORM_BUFFER_BINDINGS 0x8A2F
#define AzGl_MAX_VARYING_COMPONENTS 0x8B4B
#define AzGl_MAX_VARYING_FLOATS 0x8B4B
#define AzGl_MAX_VARYING_VECTORS 0x8DFC
#define AzGl_MAX_VERTEX_ATTRIBS 0x8869
#define AzGl_MAX_VERTEX_OUTPUT_COMPONENTS 0x9122
#define AzGl_MAX_VERTEX_TEXTURE_IMAGE_UNITS 0x8B4C
#define AzGl_MAX_VERTEX_UNIFORM_BLOCKS 0x8A2B
#define AzGl_MAX_VERTEX_UNIFORM_COMPONENTS 0x8B4A
#define AzGl_MAX_VERTEX_UNIFORM_VECTORS 0x8DFB
#define AzGl_MAX_VIEWPORT_DIMS 0x0D3A
#define AzGl_MEDIUM_FLOAT 0x8DF1
#define AzGl_MEDIUM_INT 0x8DF4
#define AzGl_MIN 0x8007
#define AzGl_MINOR_VERSION 0x821C
#define AzGl_MIN_PROGRAM_TEXEL_OFFSET 0x8904
#define AzGl_MIRRORED_REPEAT 0x8370
#define AzGl_MODELVIEW 0x1700
#define AzGl_MODELVIEW_MATRIX 0x0BA6
#define AzGl_MODELVIEW_STACK_DEPTH 0x0BA3
#define AzGl_MODULATE 0x2100
#define AzGl_MULT 0x0103
#define AzGl_MULTIPLY_KHR 0x9294
#define AzGl_MULTISAMPLE 0x809D
#define AzGl_MULTISAMPLE_BIT 0x20000000
#define AzGl_N3F_V3F 0x2A25
#define AzGl_NAME_STACK_DEPTH 0x0D70
#define AzGl_NAND 0x150E
#define AzGl_NEAREST 0x2600
#define AzGl_NEAREST_MIPMAP_LINEAR 0x2702
#define AzGl_NEAREST_MIPMAP_NEAREST 0x2700
#define AzGl_NEVER 0x0200
#define AzGl_NICEST 0x1102
#define AzGl_NONE 0
#define AzGl_NOOP 0x1505
#define AzGl_NOR 0x1508
#define AzGl_NORMALIZE 0x0BA1
#define AzGl_NORMAL_ARRAY 0x8075
#define AzGl_NORMAL_ARRAY_BUFFER_BINDING 0x8897
#define AzGl_NORMAL_ARRAY_POINTER 0x808F
#define AzGl_NORMAL_ARRAY_STRIDE 0x807F
#define AzGl_NORMAL_ARRAY_TYPE 0x807E
#define AzGl_NORMAL_MAP 0x8511
#define AzGl_NOTEQUAL 0x0205
#define AzGl_NO_ERROR 0
#define AzGl_NUM_COMPRESSED_TEXTURE_FORMATS 0x86A2
#define AzGl_NUM_EXTENSIONS 0x821D
#define AzGl_NUM_PROGRAM_BINARY_FORMATS 0x87FE
#define AzGl_NUM_SAMPLE_COUNTS 0x9380
#define AzGl_NUM_SHADER_BINARY_FORMATS 0x8DF9
#define AzGl_OBJECT_LINEAR 0x2401
#define AzGl_OBJECT_PLANE 0x2501
#define AzGl_OBJECT_TYPE 0x9112
#define AzGl_ONE 1
#define AzGl_ONE_MINUS_CONSTANT_ALPHA 0x8004
#define AzGl_ONE_MINUS_CONSTANT_COLOR 0x8002
#define AzGl_ONE_MINUS_DST_ALPHA 0x0305
#define AzGl_ONE_MINUS_DST_COLOR 0x0307
#define AzGl_ONE_MINUS_SRC1_ALPHA 0x88FB
#define AzGl_ONE_MINUS_SRC1_COLOR 0x88FA
#define AzGl_ONE_MINUS_SRC_ALPHA 0x0303
#define AzGl_ONE_MINUS_SRC_COLOR 0x0301
#define AzGl_OPERAND0_ALPHA 0x8598
#define AzGl_OPERAND0_RGB 0x8590
#define AzGl_OPERAND1_ALPHA 0x8599
#define AzGl_OPERAND1_RGB 0x8591
#define AzGl_OPERAND2_ALPHA 0x859A
#define AzGl_OPERAND2_RGB 0x8592
#define AzGl_OR 0x1507
#define AzGl_ORDER 0x0A01
#define AzGl_OR_INVERTED 0x150D
#define AzGl_OR_REVERSE 0x150B
#define AzGl_OUT_OF_MEMORY 0x0505
#define AzGl_OVERLAY_KHR 0x9296
#define AzGl_PACK_ALIGNMENT 0x0D05
#define AzGl_PACK_IMAGE_HEIGHT 0x806C
#define AzGl_PACK_LSB_FIRST 0x0D01
#define AzGl_PACK_ROW_LENGTH 0x0D02
#define AzGl_PACK_SKIP_IMAGES 0x806B
#define AzGl_PACK_SKIP_PIXELS 0x0D04
#define AzGl_PACK_SKIP_ROWS 0x0D03
#define AzGl_PACK_SWAP_BYTES 0x0D00
#define AzGl_PASS_THROUGH_TOKEN 0x0700
#define AzGl_PERSPECTIVE_CORRECTION_HINT 0x0C50
#define AzGl_PIXEL_MAP_A_TO_A 0x0C79
#define AzGl_PIXEL_MAP_A_TO_A_SIZE 0x0CB9
#define AzGl_PIXEL_MAP_B_TO_B 0x0C78
#define AzGl_PIXEL_MAP_B_TO_B_SIZE 0x0CB8
#define AzGl_PIXEL_MAP_G_TO_G 0x0C77
#define AzGl_PIXEL_MAP_G_TO_G_SIZE 0x0CB7
#define AzGl_PIXEL_MAP_I_TO_A 0x0C75
#define AzGl_PIXEL_MAP_I_TO_A_SIZE 0x0CB5
#define AzGl_PIXEL_MAP_I_TO_B 0x0C74
#define AzGl_PIXEL_MAP_I_TO_B_SIZE 0x0CB4
#define AzGl_PIXEL_MAP_I_TO_G 0x0C73
#define AzGl_PIXEL_MAP_I_TO_G_SIZE 0x0CB3
#define AzGl_PIXEL_MAP_I_TO_I 0x0C70
#define AzGl_PIXEL_MAP_I_TO_I_SIZE 0x0CB0
#define AzGl_PIXEL_MAP_I_TO_R 0x0C72
#define AzGl_PIXEL_MAP_I_TO_R_SIZE 0x0CB2
#define AzGl_PIXEL_MAP_R_TO_R 0x0C76
#define AzGl_PIXEL_MAP_R_TO_R_SIZE 0x0CB6
#define AzGl_PIXEL_MAP_S_TO_S 0x0C71
#define AzGl_PIXEL_MAP_S_TO_S_SIZE 0x0CB1
#define AzGl_PIXEL_MODE_BIT 0x00000020
#define AzGl_PIXEL_PACK_BUFFER 0x88EB
#define AzGl_PIXEL_PACK_BUFFER_BINDING 0x88ED
#define AzGl_PIXEL_UNPACK_BUFFER 0x88EC
#define AzGl_PIXEL_UNPACK_BUFFER_BINDING 0x88EF
#define AzGl_POINT 0x1B00
#define AzGl_POINTS 0x0000
#define AzGl_POINT_BIT 0x00000002
#define AzGl_POINT_DISTANCE_ATTENUATION 0x8129
#define AzGl_POINT_FADE_THRESHOLD_SIZE 0x8128
#define AzGl_POINT_SIZE 0x0B11
#define AzGl_POINT_SIZE_GRANULARITY 0x0B13
#define AzGl_POINT_SIZE_MAX 0x8127
#define AzGl_POINT_SIZE_MIN 0x8126
#define AzGl_POINT_SIZE_RANGE 0x0B12
#define AzGl_POINT_SMOOTH 0x0B10
#define AzGl_POINT_SMOOTH_HINT 0x0C51
#define AzGl_POINT_SPRITE 0x8861
#define AzGl_POINT_SPRITE_COORD_ORIGIN 0x8CA0
#define AzGl_POINT_TOKEN 0x0701
#define AzGl_POLYGON 0x0009
#define AzGl_POLYGON_BIT 0x00000008
#define AzGl_POLYGON_MODE 0x0B40
#define AzGl_POLYGON_OFFSET_FACTOR 0x8038
#define AzGl_POLYGON_OFFSET_FILL 0x8037
#define AzGl_POLYGON_OFFSET_LINE 0x2A02
#define AzGl_POLYGON_OFFSET_POINT 0x2A01
#define AzGl_POLYGON_OFFSET_UNITS 0x2A00
#define AzGl_POLYGON_SMOOTH 0x0B41
#define AzGl_POLYGON_SMOOTH_HINT 0x0C53
#define AzGl_POLYGON_STIPPLE 0x0B42
#define AzGl_POLYGON_STIPPLE_BIT 0x00000010
#define AzGl_POLYGON_TOKEN 0x0703
#define AzGl_POSITION 0x1203
#define AzGl_PREVIOUS 0x8578
#define AzGl_PRIMARY_COLOR 0x8577
#define AzGl_PRIMITIVES_GENERATED 0x8C87
#define AzGl_PRIMITIVE_RESTART 0x8F9D
#define AzGl_PRIMITIVE_RESTART_FIXED_INDEX 0x8D69
#define AzGl_PRIMITIVE_RESTART_INDEX 0x8F9E
#define AzGl_PROGRAM 0x82E2
#define AzGl_PROGRAM_BINARY_FORMATS 0x87FF
#define AzGl_PROGRAM_BINARY_LENGTH 0x8741
#define AzGl_PROGRAM_BINARY_RETRIEVABLE_HINT 0x8257
#define AzGl_PROGRAM_KHR 0x82E2
#define AzGl_PROGRAM_PIPELINE 0x82E4
#define AzGl_PROGRAM_PIPELINE_KHR 0x82E4
#define AzGl_PROGRAM_POINT_SIZE 0x8642
#define AzGl_PROJECTION 0x1701
#define AzGl_PROJECTION_MATRIX 0x0BA7
#define AzGl_PROJECTION_STACK_DEPTH 0x0BA4
#define AzGl_PROVOKING_VERTEX 0x8E4F
#define AzGl_PROXY_TEXTURE_1D 0x8063
#define AzGl_PROXY_TEXTURE_1D_ARRAY 0x8C19
#define AzGl_PROXY_TEXTURE_2D 0x8064
#define AzGl_PROXY_TEXTURE_2D_ARRAY 0x8C1B
#define AzGl_PROXY_TEXTURE_2D_MULTISAMPLE 0x9101
#define AzGl_PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY 0x9103
#define AzGl_PROXY_TEXTURE_3D 0x8070
#define AzGl_PROXY_TEXTURE_CUBE_MAP 0x851B
#define AzGl_PROXY_TEXTURE_RECTANGLE 0x84F7
#define AzGl_PROXY_TEXTURE_RECTANGLE_ARB 0x84F7
#define AzGl_Q 0x2003
#define AzGl_QUADRATIC_ATTENUATION 0x1209
#define AzGl_QUADS 0x0007
#define AzGl_QUADS_FOLLOW_PROVOKING_VERTEX_CONVENTION 0x8E4C
#define AzGl_QUAD_STRIP 0x0008
#define AzGl_QUERY 0x82E3
#define AzGl_QUERY_BY_REGION_NO_WAIT 0x8E16
#define AzGl_QUERY_BY_REGION_WAIT 0x8E15
#define AzGl_QUERY_COUNTER_BITS 0x8864
#define AzGl_QUERY_COUNTER_BITS_EXT 0x8864
#define AzGl_QUERY_KHR 0x82E3
#define AzGl_QUERY_NO_WAIT 0x8E14
#define AzGl_QUERY_RESULT 0x8866
#define AzGl_QUERY_RESULT_AVAILABLE 0x8867
#define AzGl_QUERY_RESULT_AVAILABLE_EXT 0x8867
#define AzGl_QUERY_RESULT_EXT 0x8866
#define AzGl_QUERY_WAIT 0x8E13
#define AzGl_R 0x2002
#define AzGl_R11F_G11F_B10F 0x8C3A
#define AzGl_R16 0x822A
#define AzGl_R16F 0x822D
#define AzGl_R16F_EXT 0x822D
#define AzGl_R16I 0x8233
#define AzGl_R16UI 0x8234
#define AzGl_R16_SNORM 0x8F98
#define AzGl_R32F 0x822E
#define AzGl_R32F_EXT 0x822E
#define AzGl_R32I 0x8235
#define AzGl_R32UI 0x8236
#define AzGl_R3_G3_B2 0x2A10
#define AzGl_R8 0x8229
#define AzGl_R8I 0x8231
#define AzGl_R8UI 0x8232
#define AzGl_R8_EXT 0x8229
#define AzGl_R8_SNORM 0x8F94
#define AzGl_RASTERIZER_DISCARD 0x8C89
#define AzGl_READ_BUFFER 0x0C02
#define AzGl_READ_FRAMEBUFFER 0x8CA8
#define AzGl_READ_FRAMEBUFFER_BINDING 0x8CAA
#define AzGl_READ_ONLY 0x88B8
#define AzGl_READ_WRITE 0x88BA
#define AzGl_RED 0x1903
#define AzGl_RED_BIAS 0x0D15
#define AzGl_RED_BITS 0x0D52
#define AzGl_RED_INTEGER 0x8D94
#define AzGl_RED_SCALE 0x0D14
#define AzGl_REFLECTION_MAP 0x8512
#define AzGl_RENDER 0x1C00
#define AzGl_RENDERBUFFER 0x8D41
#define AzGl_RENDERBUFFER_ALPHA_SIZE 0x8D53
#define AzGl_RENDERBUFFER_BINDING 0x8CA7
#define AzGl_RENDERBUFFER_BLUE_SIZE 0x8D52
#define AzGl_RENDERBUFFER_DEPTH_SIZE 0x8D54
#define AzGl_RENDERBUFFER_GREEN_SIZE 0x8D51
#define AzGl_RENDERBUFFER_HEIGHT 0x8D43
#define AzGl_RENDERBUFFER_INTERNAL_FORMAT 0x8D44
#define AzGl_RENDERBUFFER_RED_SIZE 0x8D50
#define AzGl_RENDERBUFFER_SAMPLES 0x8CAB
#define AzGl_RENDERBUFFER_STENCIL_SIZE 0x8D55
#define AzGl_RENDERBUFFER_WIDTH 0x8D42
#define AzGl_RENDERER 0x1F01
#define AzGl_RENDER_MODE 0x0C40
#define AzGl_REPEAT 0x2901
#define AzGl_REPLACE 0x1E01
#define AzGl_REQUIRED_TEXTURE_IMAGE_UNITS_OES 0x8D68
#define AzGl_RESCALE_NORMAL 0x803A
#define AzGl_RETURN 0x0102
#define AzGl_RG 0x8227
#define AzGl_RG16 0x822C
#define AzGl_RG16F 0x822F
#define AzGl_RG16F_EXT 0x822F
#define AzGl_RG16I 0x8239
#define AzGl_RG16UI 0x823A
#define AzGl_RG16_SNORM 0x8F99
#define AzGl_RG32F 0x8230
#define AzGl_RG32F_EXT 0x8230
#define AzGl_RG32I 0x823B
#define AzGl_RG32UI 0x823C
#define AzGl_RG8 0x822B
#define AzGl_RG8I 0x8237
#define AzGl_RG8UI 0x8238
#define AzGl_RG8_EXT 0x822B
#define AzGl_RG8_SNORM 0x8F95
#define AzGl_RGB 0x1907
#define AzGl_RGB10 0x8052
#define AzGl_RGB10_A2 0x8059
#define AzGl_RGB10_A2UI 0x906F
#define AzGl_RGB10_A2_EXT 0x8059
#define AzGl_RGB10_EXT 0x8052
#define AzGl_RGB12 0x8053
#define AzGl_RGB16 0x8054
#define AzGl_RGB16F 0x881B
#define AzGl_RGB16F_EXT 0x881B
#define AzGl_RGB16I 0x8D89
#define AzGl_RGB16UI 0x8D77
#define AzGl_RGB16_SNORM 0x8F9A
#define AzGl_RGB32F 0x8815
#define AzGl_RGB32F_EXT 0x8815
#define AzGl_RGB32I 0x8D83
#define AzGl_RGB32UI 0x8D71
#define AzGl_RGB4 0x804F
#define AzGl_RGB5 0x8050
#define AzGl_RGB565 0x8D62
#define AzGl_RGB5_A1 0x8057
#define AzGl_RGB8 0x8051
#define AzGl_RGB8I 0x8D8F
#define AzGl_RGB8UI 0x8D7D
#define AzGl_RGB8_SNORM 0x8F96
#define AzGl_RGB9_E5 0x8C3D
#define AzGl_RGBA 0x1908
#define AzGl_RGBA12 0x805A
#define AzGl_RGBA16 0x805B
#define AzGl_RGBA16F 0x881A
#define AzGl_RGBA16F_EXT 0x881A
#define AzGl_RGBA16I 0x8D88
#define AzGl_RGBA16UI 0x8D76
#define AzGl_RGBA16_SNORM 0x8F9B
#define AzGl_RGBA2 0x8055
#define AzGl_RGBA32F 0x8814
#define AzGl_RGBA32F_EXT 0x8814
#define AzGl_RGBA32I 0x8D82
#define AzGl_RGBA32UI 0x8D70
#define AzGl_RGBA4 0x8056
#define AzGl_RGBA8 0x8058
#define AzGl_RGBA8I 0x8D8E
#define AzGl_RGBA8UI 0x8D7C
#define AzGl_RGBA8_SNORM 0x8F97
#define AzGl_RGBA_INTEGER 0x8D99
#define AzGl_RGBA_MODE 0x0C31
#define AzGl_RGB_INTEGER 0x8D98
#define AzGl_RGB_SCALE 0x8573
#define AzGl_RG_INTEGER 0x8228
#define AzGl_RIGHT 0x0407
#define AzGl_S 0x2000
#define AzGl_SAMPLER 0x82E6
#define AzGl_SAMPLER_1D 0x8B5D
#define AzGl_SAMPLER_1D_ARRAY 0x8DC0
#define AzGl_SAMPLER_1D_ARRAY_SHADOW 0x8DC3
#define AzGl_SAMPLER_1D_SHADOW 0x8B61
#define AzGl_SAMPLER_2D 0x8B5E
#define AzGl_SAMPLER_2D_ARRAY 0x8DC1
#define AzGl_SAMPLER_2D_ARRAY_SHADOW 0x8DC4
#define AzGl_SAMPLER_2D_MULTISAMPLE 0x9108
#define AzGl_SAMPLER_2D_MULTISAMPLE_ARRAY 0x910B
#define AzGl_SAMPLER_2D_RECT 0x8B63
#define AzGl_SAMPLER_2D_RECT_SHADOW 0x8B64
#define AzGl_SAMPLER_2D_SHADOW 0x8B62
#define AzGl_SAMPLER_3D 0x8B5F
#define AzGl_SAMPLER_BINDING 0x8919
#define AzGl_SAMPLER_BUFFER 0x8DC2
#define AzGl_SAMPLER_CUBE 0x8B60
#define AzGl_SAMPLER_CUBE_SHADOW 0x8DC5
#define AzGl_SAMPLER_EXTERNAL_OES 0x8D66
#define AzGl_SAMPLER_KHR 0x82E6
#define AzGl_SAMPLES 0x80A9
#define AzGl_SAMPLES_PASSED 0x8914
#define AzGl_SAMPLE_ALPHA_TO_COVERAGE 0x809E
#define AzGl_SAMPLE_ALPHA_TO_ONE 0x809F
#define AzGl_SAMPLE_BUFFERS 0x80A8
#define AzGl_SAMPLE_COVERAGE 0x80A0
#define AzGl_SAMPLE_COVERAGE_INVERT 0x80AB
#define AzGl_SAMPLE_COVERAGE_VALUE 0x80AA
#define AzGl_SAMPLE_MASK 0x8E51
#define AzGl_SAMPLE_MASK_VALUE 0x8E52
#define AzGl_SAMPLE_POSITION 0x8E50
#define AzGl_SCISSOR_BIT 0x00080000
#define AzGl_SCISSOR_BOX 0x0C10
#define AzGl_SCISSOR_TEST 0x0C11
#define AzGl_SCREEN_KHR 0x9295
#define AzGl_SECONDARY_COLOR_ARRAY 0x845E
#define AzGl_SECONDARY_COLOR_ARRAY_BUFFER_BINDING 0x889C
#define AzGl_SECONDARY_COLOR_ARRAY_POINTER 0x845D
#define AzGl_SECONDARY_COLOR_ARRAY_SIZE 0x845A
#define AzGl_SECONDARY_COLOR_ARRAY_STRIDE 0x845C
#define AzGl_SECONDARY_COLOR_ARRAY_TYPE 0x845B
#define AzGl_SELECT 0x1C02
#define AzGl_SELECTION_BUFFER_POINTER 0x0DF3
#define AzGl_SELECTION_BUFFER_SIZE 0x0DF4
#define AzGl_SEPARATE_ATTRIBS 0x8C8D
#define AzGl_SEPARATE_SPECULAR_COLOR 0x81FA
#define AzGl_SET 0x150F
#define AzGl_SHADER 0x82E1
#define AzGl_SHADER_BINARY_FORMATS 0x8DF8
#define AzGl_SHADER_COMPILER 0x8DFA
#define AzGl_SHADER_KHR 0x82E1
#define AzGl_SHADER_PIXEL_LOCAL_STORAGE_EXT 0x8F64
#define AzGl_SHADER_SOURCE_LENGTH 0x8B88
#define AzGl_SHADER_TYPE 0x8B4F
#define AzGl_SHADE_MODEL 0x0B54
#define AzGl_SHADING_LANGUAGE_VERSION 0x8B8C
#define AzGl_SHININESS 0x1601
#define AzGl_SHORT 0x1402
#define AzGl_SIGNALED 0x9119
#define AzGl_SIGNED_NORMALIZED 0x8F9C
#define AzGl_SINGLE_COLOR 0x81F9
#define AzGl_SLUMINANCE 0x8C46
#define AzGl_SLUMINANCE8 0x8C47
#define AzGl_SLUMINANCE8_ALPHA8 0x8C45
#define AzGl_SLUMINANCE_ALPHA 0x8C44
#define AzGl_SMOOTH 0x1D01
#define AzGl_SMOOTH_LINE_WIDTH_GRANULARITY 0x0B23
#define AzGl_SMOOTH_LINE_WIDTH_RANGE 0x0B22
#define AzGl_SMOOTH_POINT_SIZE_GRANULARITY 0x0B13
#define AzGl_SMOOTH_POINT_SIZE_RANGE 0x0B12
#define AzGl_SOFTLIGHT_KHR 0x929C
#define AzGl_SOURCE0_ALPHA 0x8588
#define AzGl_SOURCE0_RGB 0x8580
#define AzGl_SOURCE1_ALPHA 0x8589
#define AzGl_SOURCE1_RGB 0x8581
#define AzGl_SOURCE2_ALPHA 0x858A
#define AzGl_SOURCE2_RGB 0x8582
#define AzGl_SPECULAR 0x1202
#define AzGl_SPHERE_MAP 0x2402
#define AzGl_SPOT_CUTOFF 0x1206
#define AzGl_SPOT_DIRECTION 0x1204
#define AzGl_SPOT_EXPONENT 0x1205
#define AzGl_SRC0_ALPHA 0x8588
#define AzGl_SRC0_RGB 0x8580
#define AzGl_SRC1_ALPHA 0x8589
#define AzGl_SRC1_COLOR 0x88F9
#define AzGl_SRC1_RGB 0x8581
#define AzGl_SRC2_ALPHA 0x858A
#define AzGl_SRC2_RGB 0x8582
#define AzGl_SRC_ALPHA 0x0302
#define AzGl_SRC_ALPHA_SATURATE 0x0308
#define AzGl_SRC_COLOR 0x0300
#define AzGl_SRGB 0x8C40
#define AzGl_SRGB8 0x8C41
#define AzGl_SRGB8_ALPHA8 0x8C43
#define AzGl_SRGB_ALPHA 0x8C42
#define AzGl_STACK_OVERFLOW 0x0503
#define AzGl_STACK_OVERFLOW_KHR 0x0503
#define AzGl_STACK_UNDERFLOW 0x0504
#define AzGl_STACK_UNDERFLOW_KHR 0x0504
#define AzGl_STATIC_COPY 0x88E6
#define AzGl_STATIC_DRAW 0x88E4
#define AzGl_STATIC_READ 0x88E5
#define AzGl_STENCIL 0x1802
#define AzGl_STENCIL_ATTACHMENT 0x8D20
#define AzGl_STENCIL_BACK_FAIL 0x8801
#define AzGl_STENCIL_BACK_FUNC 0x8800
#define AzGl_STENCIL_BACK_PASS_DEPTH_FAIL 0x8802
#define AzGl_STENCIL_BACK_PASS_DEPTH_PASS 0x8803
#define AzGl_STENCIL_BACK_REF 0x8CA3
#define AzGl_STENCIL_BACK_VALUE_MASK 0x8CA4
#define AzGl_STENCIL_BACK_WRITEMASK 0x8CA5
#define AzGl_STENCIL_BITS 0x0D57
#define AzGl_STENCIL_BUFFER_BIT 0x00000400
#define AzGl_STENCIL_CLEAR_VALUE 0x0B91
#define AzGl_STENCIL_FAIL 0x0B94
#define AzGl_STENCIL_FUNC 0x0B92
#define AzGl_STENCIL_INDEX 0x1901
#define AzGl_STENCIL_INDEX1 0x8D46
#define AzGl_STENCIL_INDEX16 0x8D49
#define AzGl_STENCIL_INDEX4 0x8D47
#define AzGl_STENCIL_INDEX8 0x8D48
#define AzGl_STENCIL_PASS_DEPTH_FAIL 0x0B95
#define AzGl_STENCIL_PASS_DEPTH_PASS 0x0B96
#define AzGl_STENCIL_REF 0x0B97
#define AzGl_STENCIL_TEST 0x0B90
#define AzGl_STENCIL_VALUE_MASK 0x0B93
#define AzGl_STENCIL_WRITEMASK 0x0B98
#define AzGl_STEREO 0x0C33
#define AzGl_STORAGE_CACHED_APPLE 0x85BE
#define AzGl_STORAGE_PRIVATE_APPLE 0x85BD
#define AzGl_STORAGE_SHARED_APPLE 0x85BF
#define AzGl_STREAM_COPY 0x88E2
#define AzGl_STREAM_DRAW 0x88E0
#define AzGl_STREAM_READ 0x88E1
#define AzGl_SUBPIXEL_BITS 0x0D50
#define AzGl_SUBTRACT 0x84E7
#define AzGl_SYNC_CONDITION 0x9113
#define AzGl_SYNC_FENCE 0x9116
#define AzGl_SYNC_FLAGS 0x9115
#define AzGl_SYNC_FLUSH_COMMANDS_BIT 0x00000001
#define AzGl_SYNC_GPU_COMMANDS_COMPLETE 0x9117
#define AzGl_SYNC_STATUS 0x9114
#define AzGl_T 0x2001
#define AzGl_T2F_C3F_V3F 0x2A2A
#define AzGl_T2F_C4F_N3F_V3F 0x2A2C
#define AzGl_T2F_C4UB_V3F 0x2A29
#define AzGl_T2F_N3F_V3F 0x2A2B
#define AzGl_T2F_V3F 0x2A27
#define AzGl_T4F_C4F_N3F_V4F 0x2A2D
#define AzGl_T4F_V4F 0x2A28
#define AzGl_TEXTURE 0x1702
#define AzGl_TEXTURE0 0x84C0
#define AzGl_TEXTURE1 0x84C1
#define AzGl_TEXTURE10 0x84CA
#define AzGl_TEXTURE11 0x84CB
#define AzGl_TEXTURE12 0x84CC
#define AzGl_TEXTURE13 0x84CD
#define AzGl_TEXTURE14 0x84CE
#define AzGl_TEXTURE15 0x84CF
#define AzGl_TEXTURE16 0x84D0
#define AzGl_TEXTURE17 0x84D1
#define AzGl_TEXTURE18 0x84D2
#define AzGl_TEXTURE19 0x84D3
#define AzGl_TEXTURE2 0x84C2
#define AzGl_TEXTURE20 0x84D4
#define AzGl_TEXTURE21 0x84D5
#define AzGl_TEXTURE22 0x84D6
#define AzGl_TEXTURE23 0x84D7
#define AzGl_TEXTURE24 0x84D8
#define AzGl_TEXTURE25 0x84D9
#define AzGl_TEXTURE26 0x84DA
#define AzGl_TEXTURE27 0x84DB
#define AzGl_TEXTURE28 0x84DC
#define AzGl_TEXTURE29 0x84DD
#define AzGl_TEXTURE3 0x84C3
#define AzGl_TEXTURE30 0x84DE
#define AzGl_TEXTURE31 0x84DF
#define AzGl_TEXTURE4 0x84C4
#define AzGl_TEXTURE5 0x84C5
#define AzGl_TEXTURE6 0x84C6
#define AzGl_TEXTURE7 0x84C7
#define AzGl_TEXTURE8 0x84C8
#define AzGl_TEXTURE9 0x84C9
#define AzGl_TEXTURE_1D 0x0DE0
#define AzGl_TEXTURE_1D_ARRAY 0x8C18
#define AzGl_TEXTURE_2D 0x0DE1
#define AzGl_TEXTURE_2D_ARRAY 0x8C1A
#define AzGl_TEXTURE_2D_MULTISAMPLE 0x9100
#define AzGl_TEXTURE_2D_MULTISAMPLE_ARRAY 0x9102
#define AzGl_TEXTURE_3D 0x806F
#define AzGl_TEXTURE_ALPHA_SIZE 0x805F
#define AzGl_TEXTURE_ALPHA_TYPE 0x8C13
#define AzGl_TEXTURE_BASE_LEVEL 0x813C
#define AzGl_TEXTURE_BINDING_1D 0x8068
#define AzGl_TEXTURE_BINDING_1D_ARRAY 0x8C1C
#define AzGl_TEXTURE_BINDING_2D 0x8069
#define AzGl_TEXTURE_BINDING_2D_ARRAY 0x8C1D
#define AzGl_TEXTURE_BINDING_2D_MULTISAMPLE 0x9104
#define AzGl_TEXTURE_BINDING_2D_MULTISAMPLE_ARRAY 0x9105
#define AzGl_TEXTURE_BINDING_3D 0x806A
#define AzGl_TEXTURE_BINDING_BUFFER 0x8C2C
#define AzGl_TEXTURE_BINDING_CUBE_MAP 0x8514
#define AzGl_TEXTURE_BINDING_EXTERNAL_OES 0x8D67
#define AzGl_TEXTURE_BINDING_RECTANGLE 0x84F6
#define AzGl_TEXTURE_BINDING_RECTANGLE_ARB 0x84F6
#define AzGl_TEXTURE_BIT 0x00040000
#define AzGl_TEXTURE_BLUE_SIZE 0x805E
#define AzGl_TEXTURE_BLUE_TYPE 0x8C12
#define AzGl_TEXTURE_BORDER 0x1005
#define AzGl_TEXTURE_BORDER_COLOR 0x1004
#define AzGl_TEXTURE_BUFFER 0x8C2A
#define AzGl_TEXTURE_BUFFER_DATA_STORE_BINDING 0x8C2D
#define AzGl_TEXTURE_COMPARE_FUNC 0x884D
#define AzGl_TEXTURE_COMPARE_MODE 0x884C
#define AzGl_TEXTURE_COMPONENTS 0x1003
#define AzGl_TEXTURE_COMPRESSED 0x86A1
#define AzGl_TEXTURE_COMPRESSED_IMAGE_SIZE 0x86A0
#define AzGl_TEXTURE_COMPRESSION_HINT 0x84EF
#define AzGl_TEXTURE_COORD_ARRAY 0x8078
#define AzGl_TEXTURE_COORD_ARRAY_BUFFER_BINDING 0x889A
#define AzGl_TEXTURE_COORD_ARRAY_POINTER 0x8092
#define AzGl_TEXTURE_COORD_ARRAY_SIZE 0x8088
#define AzGl_TEXTURE_COORD_ARRAY_STRIDE 0x808A
#define AzGl_TEXTURE_COORD_ARRAY_TYPE 0x8089
#define AzGl_TEXTURE_CUBE_MAP 0x8513
#define AzGl_TEXTURE_CUBE_MAP_NEGATIVE_X 0x8516
#define AzGl_TEXTURE_CUBE_MAP_NEGATIVE_Y 0x8518
#define AzGl_TEXTURE_CUBE_MAP_NEGATIVE_Z 0x851A
#define AzGl_TEXTURE_CUBE_MAP_POSITIVE_X 0x8515
#define AzGl_TEXTURE_CUBE_MAP_POSITIVE_Y 0x8517
#define AzGl_TEXTURE_CUBE_MAP_POSITIVE_Z 0x8519
#define AzGl_TEXTURE_CUBE_MAP_SEAMLESS 0x884F
#define AzGl_TEXTURE_DEPTH 0x8071
#define AzGl_TEXTURE_DEPTH_SIZE 0x884A
#define AzGl_TEXTURE_DEPTH_TYPE 0x8C16
#define AzGl_TEXTURE_ENV 0x2300
#define AzGl_TEXTURE_ENV_COLOR 0x2201
#define AzGl_TEXTURE_ENV_MODE 0x2200
#define AzGl_TEXTURE_EXTERNAL_OES 0x8D65
#define AzGl_TEXTURE_FILTER_CONTROL 0x8500
#define AzGl_TEXTURE_FIXED_SAMPLE_LOCATIONS 0x9107
#define AzGl_TEXTURE_GEN_MODE 0x2500
#define AzGl_TEXTURE_GEN_Q 0x0C63
#define AzGl_TEXTURE_GEN_R 0x0C62
#define AzGl_TEXTURE_GEN_S 0x0C60
#define AzGl_TEXTURE_GEN_T 0x0C61
#define AzGl_TEXTURE_GREEN_SIZE 0x805D
#define AzGl_TEXTURE_GREEN_TYPE 0x8C11
#define AzGl_TEXTURE_HEIGHT 0x1001
#define AzGl_TEXTURE_IMMUTABLE_FORMAT 0x912F
#define AzGl_TEXTURE_IMMUTABLE_FORMAT_EXT 0x912F
#define AzGl_TEXTURE_IMMUTABLE_LEVELS 0x82DF
#define AzGl_TEXTURE_INTENSITY_SIZE 0x8061
#define AzGl_TEXTURE_INTENSITY_TYPE 0x8C15
#define AzGl_TEXTURE_INTERNAL_FORMAT 0x1003
#define AzGl_TEXTURE_LOD_BIAS 0x8501
#define AzGl_TEXTURE_LUMINANCE_SIZE 0x8060
#define AzGl_TEXTURE_LUMINANCE_TYPE 0x8C14
#define AzGl_TEXTURE_MAG_FILTER 0x2800
#define AzGl_TEXTURE_MATRIX 0x0BA8
#define AzGl_TEXTURE_MAX_ANISOTROPY_EXT 0x84FE
#define AzGl_TEXTURE_MAX_LEVEL 0x813D
#define AzGl_TEXTURE_MAX_LOD 0x813B
#define AzGl_TEXTURE_MIN_FILTER 0x2801
#define AzGl_TEXTURE_MIN_LOD 0x813A
#define AzGl_TEXTURE_PRIORITY 0x8066
#define AzGl_TEXTURE_RANGE_LENGTH_APPLE 0x85B7
#define AzGl_TEXTURE_RANGE_POINTER_APPLE 0x85B8
#define AzGl_TEXTURE_RECTANGLE 0x84F5
#define AzGl_TEXTURE_RECTANGLE_ARB 0x84F5
#define AzGl_TEXTURE_RED_SIZE 0x805C
#define AzGl_TEXTURE_RED_TYPE 0x8C10
#define AzGl_TEXTURE_RESIDENT 0x8067
#define AzGl_TEXTURE_SAMPLES 0x9106
#define AzGl_TEXTURE_SHARED_SIZE 0x8C3F
#define AzGl_TEXTURE_STACK_DEPTH 0x0BA5
#define AzGl_TEXTURE_STENCIL_SIZE 0x88F1
#define AzGl_TEXTURE_STORAGE_HINT_APPLE 0x85BC
#define AzGl_TEXTURE_SWIZZLE_A 0x8E45
#define AzGl_TEXTURE_SWIZZLE_B 0x8E44
#define AzGl_TEXTURE_SWIZZLE_G 0x8E43
#define AzGl_TEXTURE_SWIZZLE_R 0x8E42
#define AzGl_TEXTURE_SWIZZLE_RGBA 0x8E46
#define AzGl_TEXTURE_USAGE_ANGLE 0x93A2
#define AzGl_TEXTURE_WIDTH 0x1000
#define AzGl_TEXTURE_WRAP_R 0x8072
#define AzGl_TEXTURE_WRAP_S 0x2802
#define AzGl_TEXTURE_WRAP_T 0x2803
#define AzGl_TIMEOUT_EXPIRED 0x911B
#define AzGl_TIMEOUT_IGNORED 0xFFFFFFFFFFFFFFFF
#define AzGl_TIMESTAMP 0x8E28
#define AzGl_TIMESTAMP_EXT 0x8E28
#define AzGl_TIME_ELAPSED 0x88BF
#define AzGl_TIME_ELAPSED_EXT 0x88BF
#define AzGl_TRANSFORM_BIT 0x00001000
#define AzGl_TRANSFORM_FEEDBACK 0x8E22
#define AzGl_TRANSFORM_FEEDBACK_ACTIVE 0x8E24
#define AzGl_TRANSFORM_FEEDBACK_BINDING 0x8E25
#define AzGl_TRANSFORM_FEEDBACK_BUFFER 0x8C8E
#define AzGl_TRANSFORM_FEEDBACK_BUFFER_BINDING 0x8C8F
#define AzGl_TRANSFORM_FEEDBACK_BUFFER_MODE 0x8C7F
#define AzGl_TRANSFORM_FEEDBACK_BUFFER_SIZE 0x8C85
#define AzGl_TRANSFORM_FEEDBACK_BUFFER_START 0x8C84
#define AzGl_TRANSFORM_FEEDBACK_PAUSED 0x8E23
#define AzGl_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN 0x8C88
#define AzGl_TRANSFORM_FEEDBACK_VARYINGS 0x8C83
#define AzGl_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH 0x8C76
#define AzGl_TRANSPOSE_COLOR_MATRIX 0x84E6
#define AzGl_TRANSPOSE_MODELVIEW_MATRIX 0x84E3
#define AzGl_TRANSPOSE_PROJECTION_MATRIX 0x84E4
#define AzGl_TRANSPOSE_TEXTURE_MATRIX 0x84E5
#define AzGl_TRIANGLES 0x0004
#define AzGl_TRIANGLES_ADJACENCY 0x000C
#define AzGl_TRIANGLE_FAN 0x0006
#define AzGl_TRIANGLE_STRIP 0x0005
#define AzGl_TRIANGLE_STRIP_ADJACENCY 0x000D
#define AzGl_TRUE 1
#define AzGl_UNIFORM_ARRAY_STRIDE 0x8A3C
#define AzGl_UNIFORM_BLOCK_ACTIVE_UNIFORMS 0x8A42
#define AzGl_UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES 0x8A43
#define AzGl_UNIFORM_BLOCK_BINDING 0x8A3F
#define AzGl_UNIFORM_BLOCK_DATA_SIZE 0x8A40
#define AzGl_UNIFORM_BLOCK_INDEX 0x8A3A
#define AzGl_UNIFORM_BLOCK_NAME_LENGTH 0x8A41
#define AzGl_UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER 0x8A46
#define AzGl_UNIFORM_BLOCK_REFERENCED_BY_GEOMETRY_SHADER 0x8A45
#define AzGl_UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER 0x8A44
#define AzGl_UNIFORM_BUFFER 0x8A11
#define AzGl_UNIFORM_BUFFER_BINDING 0x8A28
#define AzGl_UNIFORM_BUFFER_OFFSET_ALIGNMENT 0x8A34
#define AzGl_UNIFORM_BUFFER_SIZE 0x8A2A
#define AzGl_UNIFORM_BUFFER_START 0x8A29
#define AzGl_UNIFORM_IS_ROW_MAJOR 0x8A3E
#define AzGl_UNIFORM_MATRIX_STRIDE 0x8A3D
#define AzGl_UNIFORM_NAME_LENGTH 0x8A39
#define AzGl_UNIFORM_OFFSET 0x8A3B
#define AzGl_UNIFORM_SIZE 0x8A38
#define AzGl_UNIFORM_TYPE 0x8A37
#define AzGl_UNPACK_ALIGNMENT 0x0CF5
#define AzGl_UNPACK_CLIENT_STORAGE_APPLE 0x85B2
#define AzGl_UNPACK_IMAGE_HEIGHT 0x806E
#define AzGl_UNPACK_LSB_FIRST 0x0CF1
#define AzGl_UNPACK_ROW_LENGTH 0x0CF2
#define AzGl_UNPACK_SKIP_IMAGES 0x806D
#define AzGl_UNPACK_SKIP_PIXELS 0x0CF4
#define AzGl_UNPACK_SKIP_ROWS 0x0CF3
#define AzGl_UNPACK_SWAP_BYTES 0x0CF0
#define AzGl_UNSIGNALED 0x9118
#define AzGl_UNSIGNED_BYTE 0x1401
#define AzGl_UNSIGNED_BYTE_2_3_3_REV 0x8362
#define AzGl_UNSIGNED_BYTE_3_3_2 0x8032
#define AzGl_UNSIGNED_INT 0x1405
#define AzGl_UNSIGNED_INT_10F_11F_11F_REV 0x8C3B
#define AzGl_UNSIGNED_INT_10_10_10_2 0x8036
#define AzGl_UNSIGNED_INT_24_8 0x84FA
#define AzGl_UNSIGNED_INT_2_10_10_10_REV 0x8368
#define AzGl_UNSIGNED_INT_5_9_9_9_REV 0x8C3E
#define AzGl_UNSIGNED_INT_8_8_8_8 0x8035
#define AzGl_UNSIGNED_INT_8_8_8_8_REV 0x8367
#define AzGl_UNSIGNED_INT_SAMPLER_1D 0x8DD1
#define AzGl_UNSIGNED_INT_SAMPLER_1D_ARRAY 0x8DD6
#define AzGl_UNSIGNED_INT_SAMPLER_2D 0x8DD2
#define AzGl_UNSIGNED_INT_SAMPLER_2D_ARRAY 0x8DD7
#define AzGl_UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE 0x910A
#define AzGl_UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY 0x910D
#define AzGl_UNSIGNED_INT_SAMPLER_2D_RECT 0x8DD5
#define AzGl_UNSIGNED_INT_SAMPLER_3D 0x8DD3
#define AzGl_UNSIGNED_INT_SAMPLER_BUFFER 0x8DD8
#define AzGl_UNSIGNED_INT_SAMPLER_CUBE 0x8DD4
#define AzGl_UNSIGNED_INT_VEC2 0x8DC6
#define AzGl_UNSIGNED_INT_VEC3 0x8DC7
#define AzGl_UNSIGNED_INT_VEC4 0x8DC8
#define AzGl_UNSIGNED_NORMALIZED 0x8C17
#define AzGl_UNSIGNED_SHORT 0x1403
#define AzGl_UNSIGNED_SHORT_1_5_5_5_REV 0x8366
#define AzGl_UNSIGNED_SHORT_4_4_4_4 0x8033
#define AzGl_UNSIGNED_SHORT_4_4_4_4_REV 0x8365
#define AzGl_UNSIGNED_SHORT_5_5_5_1 0x8034
#define AzGl_UNSIGNED_SHORT_5_6_5 0x8363
#define AzGl_UNSIGNED_SHORT_5_6_5_REV 0x8364
#define AzGl_UPPER_LEFT 0x8CA2
#define AzGl_V2F 0x2A20
#define AzGl_V3F 0x2A21
#define AzGl_VALIDATE_STATUS 0x8B83
#define AzGl_VENDOR 0x1F00
#define AzGl_VERSION 0x1F02
#define AzGl_VERTEX_ARRAY 0x8074
#define AzGl_VERTEX_ARRAY_BINDING 0x85B5
#define AzGl_VERTEX_ARRAY_BINDING_APPLE 0x85B5
#define AzGl_VERTEX_ARRAY_BUFFER_BINDING 0x8896
#define AzGl_VERTEX_ARRAY_KHR 0x8074
#define AzGl_VERTEX_ARRAY_POINTER 0x808E
#define AzGl_VERTEX_ARRAY_SIZE 0x807A
#define AzGl_VERTEX_ARRAY_STRIDE 0x807C
#define AzGl_VERTEX_ARRAY_TYPE 0x807B
#define AzGl_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING 0x889F
#define AzGl_VERTEX_ATTRIB_ARRAY_DIVISOR 0x88FE
#define AzGl_VERTEX_ATTRIB_ARRAY_ENABLED 0x8622
#define AzGl_VERTEX_ATTRIB_ARRAY_INTEGER 0x88FD
#define AzGl_VERTEX_ATTRIB_ARRAY_NORMALIZED 0x886A
#define AzGl_VERTEX_ATTRIB_ARRAY_POINTER 0x8645
#define AzGl_VERTEX_ATTRIB_ARRAY_SIZE 0x8623
#define AzGl_VERTEX_ATTRIB_ARRAY_STRIDE 0x8624
#define AzGl_VERTEX_ATTRIB_ARRAY_TYPE 0x8625
#define AzGl_VERTEX_PROGRAM_POINT_SIZE 0x8642
#define AzGl_VERTEX_PROGRAM_TWO_SIDE 0x8643
#define AzGl_VERTEX_SHADER 0x8B31
#define AzGl_VIEWPORT 0x0BA2
#define AzGl_VIEWPORT_BIT 0x00000800
#define AzGl_WAIT_FAILED 0x911D
#define AzGl_WEIGHT_ARRAY_BUFFER_BINDING 0x889E
#define AzGl_WRITE_ONLY 0x88B9
#define AzGl_XOR 0x1506
#define AzGl_ZERO 0
#define AzGl_ZOOM_X 0x0D16
#define AzGl_ZOOM_Y 0x0D17

/* Union helpers */



/* Macro to turn a compile-time string into a compile-time AzString
 *
 * static AzString foo = AzString_fromConstStr(\"MyString\");
 */
#define AzString_fromConstStr(s) { \
    .vec = { \
        .ptr = s, \
        .len = sizeof(s) - 1, \
        .cap = sizeof(s) - 1, \
        .destructor = AzU8VecDestructor_NoDestructor, \
    } \
}

/* Macro to initialize a compile-time AzNodeData struct
 *
 * static AzNodeData foo = AzNodeData_new(AzNodeType_Div);
 */
#define AzNodeData_new(nt) { \
    .node_type = nt, \
    .dataset = AzOptionRefAny_None, \
    .ids_and_classes = AzIdOrClassVec_empty, \
    .callbacks = AzCallbackDataVec_empty, \
    .inline_css_props = AzNodeDataInlineCssPropertyVec_empty, \
    .clip_mask = AzOptionImageMask_None, \
    .tab_index = AzOptionTabIndex_None, \
}

/* Macro to initialize a compile-time AzDom struct
 *
 * static AzDom foo = AzDom_new(AzNodeType_Div);
 */
#define AzDom_new(nt) { \
    .root = AzNodeData_new(nt),\
    .children = AzDomVec_empty, \
    .total_children = 0, \
}

/* Macro to initialize the default AppConfig struct, must be in a header file
 * so that the LayoutSolverVersion is defined by the binary, not the library -
 * this way upgrading the library won't break the application layout
 *
 * AzAppConfig foo = AzAppConfig_default();
 */
#define AzAppConfig_default(...) { \
    .layout_solver = AzLayoutSolverVersion_March2021, \
    .log_level = AzAppLogLevel_Error, \
    .enable_visual_panic_hook = true, \
    .enable_logging_on_panic = true, \
    .enable_tab_navigation = true, \
    .system_callbacks = AzSystemCallbacks_libraryInternal(), \
}

/* Macro to generate reflection metadata for a given struct - for a "structName" of "foo", generates:
 *
 * constants:
 * - a foo_RttiTypeId, which serves as the "type ID" for that struct
 * - a foo_RttiString, a compile-time string that identifies the class
 *
 * structs:
 * - struct fooRef(): immutable reference to a RefAny<foo>
 * - struct fooRefMut(): mutable reference to a RefAny<foo>
 *
 * functions:
 * - AzRefAny foo_upcast(myStructInstance): upcasts a #structName to a RefAny
 *
 * - fooRef_create(AzRefAny): creates a new fooRef, but does not yet downcast it (.ptr is set to nullptr)
 * - fooRefMut_create(AzRefAny): creates a new fooRefMut, but does not yet downcast it (.ptr is set to nullptr)
 *
 * - bool foo_downcastRef(AzRefAny, fooRef* restrict): downcasts the RefAny immutably, if true is returned then the fooRef is properly initialized
 * - bool foo_downcastMut(AzRefAny, fooRefMut* restrict): downcasts the RefAny mutably, if true is returned then the fooRef is properly initialized
 *
 * - void fooRef_delete(fooRef): disposes of the fooRef and decreases the immutable reference count
 * - void fooRefMut_delete(fooRefMut): disposes of the fooRefMut and decreases the mutable reference count
 * - bool fooRefAny_delete(AzRefAny): disposes of the AzRefAny type, returns false if the AzRefAny is not of type RefAny<foo>
 *
 * USAGE:
 *
 *     typedef struct { } foo;
 *
 *     // -- destructor of foo, azul will call this function once the refcount hits 0
 *     // note: the function expects a void*, but you can just use a foo*
 *     void fooDestructor(foo* restrict destructorPtr) { }
 *
 *     AZ_REFLECT(foo, fooDestructor)
*/
#define AZ_REFLECT(structName, destructor) \
    /* in C all statics are guaranteed to have a unique address, use that address as a TypeId */ \
    static uint64_t const structName##_RttiTypePtrId = 0; \
    static uint64_t const structName##_RttiTypeId = (uint64_t)(&structName##_RttiTypePtrId); \
    static AzString const structName##_Type_RttiString = AzString_fromConstStr(#structName); \
    \
    AzRefAny structName##_upcast(structName const s) { \
        return AzRefAny_newC(&s, sizeof(structName), structName##_RttiTypeId, structName##_Type_RttiString, destructor); \
    } \
    \
    /* generate structNameRef and structNameRefMut structs*/ \
    typedef struct { const structName* ptr; AzRefCount sharing_info; } structName##Ref; \
    typedef struct { structName* restrict ptr; AzRefCount sharing_info; } structName##RefMut; \
    \
    structName##Ref structName##Ref_create(AzRefAny* const refany) { \
        structName##Ref val = { .ptr = 0, .sharing_info = AzRefCount_deepCopy(&refany->sharing_info) };    \
        return val;    \
    } \
    \
    structName##RefMut structName##RefMut_create(AzRefAny* const refany) { \
        structName##RefMut val = { .ptr = 0, .sharing_info = AzRefCount_deepCopy(&refany->sharing_info), };    \
        return val;    \
    } \
    \
    /* if downcastRef returns true, the downcast worked */ \
    bool structName##_downcastRef(AzRefAny* restrict refany, structName##Ref * restrict result) { \
        if (!AzRefAny_isType(refany, structName##_RttiTypeId)) { return false; } else { \
            if (!AzRefCount_canBeShared(&refany->sharing_info)) { return false; } else {\
                AzRefCount_increaseRef(&refany->sharing_info); \
                result->ptr = (structName* const)(refany->_internal_ptr); \
                return true; \
            } \
        } \
    } \
    \
    /* if downcastRefMut returns true, the mutable downcast worked */ \
    bool structName##_downcastMut(AzRefAny* restrict refany, structName##RefMut * restrict result) { \
        if (!AzRefAny_isType(refany, structName##_RttiTypeId)) { return false; } else { \
            if (!AzRefCount_canBeSharedMut(&refany->sharing_info)) { return false; }  else {\
                AzRefCount_increaseRefmut(&refany->sharing_info); \
                result->ptr = (structName* restrict)(refany->_internal_ptr); \
                return true; \
            } \
        } \
    } \
    \
    /* releases a structNameRef (decreases the RefCount) */ \
    void structName##Ref_delete(structName##Ref* restrict value) { \
        AzRefCount_decreaseRef(&value->sharing_info); \
    }\
    \
    /* releases a structNameRefMut (decreases the mutable RefCount) */ \
    void structName##RefMut_delete(structName##RefMut* restrict value) { \
        AzRefCount_decreaseRefmut(&value->sharing_info); \
    }\
    /* releases a structNameRefAny (checks if the RefCount is 0 and calls the destructor) */ \
    bool structName##RefAny_delete(AzRefAny* restrict refany) { \
        if (!AzRefAny_isType(refany, structName##_RttiTypeId)) { return false; } \
        AzRefAny_delete(refany); \
        return true; \
    }

#endif /* AZUL_H */
